#!/bin/sh

echo "This script will (re)create the MySQL database for webprojectdb."
echo "Your user must already have proper access rights (read README)."
echo ""
echo "You will be asked for the database name and an optional prefix"
echo "for all table names."
echo "Are you sure?  If the database already exists, all webprojectdb-"
echo "related tables be lost.  Other tables in the db are not affected."
echo -n "Proceed(y/n)?"
read ANSWER
if [ "$ANSWER" != 'y' ] ; then
	echo "Aborted."
	exit 1
fi

echo -n "Database name (default is 'webprojectdb'): "
read DBNAME
if [ ! "$DBNAME" ]; then
	DBNAME="webprojectdb"
fi

# Note: this command fails if the DB already exists, no problem.
echo ""
echo "create database $DBNAME;" | mysql

echo ""
echo "If some access problems seem to exist, abort via ctrl-c now."
echo ""
echo "Enter the prefix to use.  Use only if you can't create a 'private'"
echo "database just for webprojectdb.  The prefix can be empty, otherwise"
echo "I suggest using something in the form of 'foo_'."
echo -n "Prefix: "
read PREFIX

./gen.pl "$PREFIX" < webprojectdb.sql | mysql $DBNAME

echo -n "Done.  Do you want to load the sample data (y/n)?"
read ANSWER
if [ "$ANSWER" != 'y' ]; then
	echo "Not loading sample data."
	exit 0
fi

./gen.pl "$PREFIX" < sampledata.sql | mysql $DBNAME

