<?php
/*
 * When an account is in "pending" state, ie it hasn't been confirmed yet, and
 * the user somehow lost the e-mail with the necessary confirmation
 * information, he can request that this be sent again.
 * When trying to login to a pending account, the user is sent here (from
 * include/session.php:session_login_valid()) via a redirection.
 *
 * Now tell the user what happened, and ask whether to resend the message.
 *
 * $Id: pending.php,v 1.2 2001/11/10 13:29:53 sf Exp $
 */

include '../include/pre.php';

if(!isset($form_user)) {
	exit_error('Error','You probably reached this page indirectly.');
}

// this doesn't do any authentication, as the user isn't logged in...
site_header('pending');

if( !isset($Resend) ) {
	$link_start="<A href=\"pending.php?Resend=1&form_user=$form_user\">";
	$link_end="</A>";
	print gm('pending:maintext',array('link_start'=>$link_start,'link_end'=>$link_end));
	site_footer();
	exit;
}

# The user must exist already, and must be pending.
$res = db_query("SELECT * FROM ".$db_prefix."user "
	. "WHERE user_id=$form_user");
$user = db_fetch_array($res);
if(!$user)
	exit_error('Error',gm('pending:invuser'));
if($user['status'] != 'P')
	exit_error('Error',gm('pending:notpending'));

# In this case, an entry in userpending must also exist.
$res = db_query("SELECT * FROM ".$db_prefix."userpending "
	. "WHERE user_id=$form_user");
$pend = db_fetch_array($res);
if(!$pend)
	exit_error('Error','Database inconsistency.');

// Now generate the mail.
$message = gm('register:registered',
	array('url'=>"http://$sys_domain" . get_link('verify') . "?confirm_hash=$pend[confirm_hash]"));
mail($user['email'],gm('register:sender'),$message,"From: noreply@$sys_maildomain");

// Tell the user.
print gm('pending:hasbeensent');
site_footer();
?>
