<?php
# Register a new user.
# $Id: register.php,v 1.4 2001/11/10 18:33:27 sf Exp $

include '../include/pre.php';    
include "$INCDIR/account.php";
include "$INCDIR/form.php";


/* Check that the register form was completely and correctly filled out.
 * Returns:
 *	''	OK
 *	'-'	error message in $register_error.
 *	else	error message *name*.
 */
function register_valid() {
	global $form_loginname, $form_pw, $form_pw2;
	global $new_user_id, $form_email, $form_realname, $register_error;
	global $sys_domain, $sys_maildomain, $db_prefix;

	if (!$form_loginname) return 'name';

	// Check whether that user_name already exists.
	$res = db_query( "SELECT user_id "
		. "FROM $db_prefix"."user "
		. "WHERE user_name LIKE '$form_loginname'" );
	if( !$res ) {
		$register_error = $GLOBALS['db_error'];
		return '-';
	}
	if( db_numrows($res) > 0 ) {
		return 'exists';
	}

	if (!$form_pw) return 'pass';
	if ($form_pw != $form_pw2) return 'mismatch';
	if (!$form_email) return 'missingemail';

	if (!account_pwvalid($form_pw)) return '-';
	if (!account_namevalid($form_loginname)) return '-';
	
	// If we got this far, it must be good.  Think up a random string.
	$confirm_hash = substr(md5($form_pw.strval(time()).strval(rand()))
		,0,16);
	$form_pw = md5($form_pw);

	$now = time();
	$query = "INSERT INTO $db_prefix"."user"
		. "(user_name,fullname,country_id,email,password,status,add_date,languages) "
		. "VALUES('$form_loginname','$form_realname',0,'$form_email','$form_pw','P','$now','')";
	$res = db_query($query);
	if( !$res ) {
		$register_error = $GLOBALS['db_error'];
		return '-';
	}

	$new_user_id = db_insertid();
	$query = "INSERT INTO $db_prefix"."userpending "
		. "VALUES('$confirm_hash',$new_user_id,'$now')";
	$res = db_query($query);
	if( !$res ) {
		$register_error = $GLOBALS['db_error'];
		return '-';
	}

	// send mail
	$url = "http://$sys_domain" . get_link('verify');
	$message = gm('register:registered',array('url'=>"$url?confirm_hash=$confirm_hash"));

	mail($form_email,gm('register:sender'),$message,"From: noreply@$sys_maildomain");

	return '';
}

// ###### first check for valid login, if so, congratulate

site_header('user_register');

if( isset($Register) ) {
	if( ($rc=register_valid()) == '' ) {
		print gm('register:confirm',array('name'=>$form_loginname));
		site_footer();
		exit;
	}
} else {
	// First visit - initialize variables
	$rc=$form_loginname=$form_pw=$form_pw2=$form_realname=$form_email='';
}

// Not valid registration, or first time to page
if( $rc == '-' ) {
	$rc = $register_error;
} elseif($rc != '') {
	$rc = gm("register:$rc");
}

form_start(array('title'=>'register:newreg','action'=>'register.php'));
if( $rc ) print "<p><FONT color=#FF0000>$rc</FONT></p>\n";
form_field(array('label'=>'strings:username','name'=>'form_loginname','value'=>$form_loginname));
form_field(array('label'=>'strings:password','name'=>'form_pw','value'=>$form_pw,'type'=>'password'));
form_field(array('label'=>'register:pwrepeat','name'=>'form_pw2','value'=>$form_pw2,'type'=>'password'));
form_field(array('label'=>'strings:fullname','name'=>'form_realname','value'=>$form_realname,'size'=>30));
print gm('register:emailinfo');
form_field(array('label'=>'strings:email','name'=>'form_email','value'=>$form_email,'size'=>30));

?>
<P><INPUT type="checkbox" name="form_mail_site" value="1" checked>
<?php print gm('register:sitemail'); ?> </P>

<P><INPUT type="submit" name="Register" value="Register"></P>
</FORM>

<?php site_footer(); ?>
