<?php
# Show a list of messages that the user could translate or whose translations
# he could update.
# $Id: translate.php,v 1.2 2001/11/10 13:56:25 sf Exp $

include '../include/pre.php';

site_header('account:translate');

// DEBUG -- don't use all languages.
// $LANG_CI = array('de'=>1,'en'=>1);

// what can the user do?
$res = db_query( "SELECT lang_from,lang_to "
	. "FROM ".$db_prefix."translator "
	. "WHERE user_id=$USER[user_id]" );

$can_trans = array();
$can_trans_i = array();
$can_trans_from = array();

while( $row = db_fetch_array($res) ) {
	$can_trans_from[] = $row['lang_from'];
	$s ="$row[lang_from]:$row[lang_to]";
	$can_trans[] = $s;
	$can_trans_i[$s] = 1;
}

$numtrans = count($LANG_CI) - 1;

if( !count($can_trans) ) {
	print gm('translate:nodef',
		array('link'=>get_link("account:translator")));
	site_footer();
	exit;
}


// Ask the user what messages to translate.
if( !isset($form_msgid) || !$form_msgid ) {
	print "Please enter the message ID of the msg to translate:<br>\n";
	print "You can also use a LIKE expression (e.g. admin:%); if the result is more than one messages, you will get a list to choose from.\n";
	print "<FORM action=\"$PHP_SELF\" method=\"get\">\n";
	print "<INPUT type=\"text\" name=\"form_msgid\" size=30><br>\n";

//	print "When searching, show only originals in this language:";
//	print "<SELECT name=\"form_lc\">\n";
//	print "<OPTION value=\"\">(all)</OPTION>\n";
//
//	$lang_table = lang_table();
//	while(list($k,$v)=each($lang_table)) {
//		print "<OPTION value=\"$k\">$v</OPTION>\n";
//	}
//	print "</SELECT><br>\n";

	print "<INPUT type=\"submit\">\n";
	print "</FORM>\n";
	site_footer();
	exit;
}


if( $form_msgid != '%' ) {
	$cond = " AND orig.message_id LIKE '$form_msgid'";
} else {
	$cond = '';
}

// of all messages that haven't been translated into all languages,
// get a list of existing translations.
$res = db_query( "SELECT orig.message_id AS msgid,orig.language_code AS o_lc,trans.language_code AS t_lc "
	. "FROM ".$db_prefix."msg orig LEFT JOIN ".$db_prefix."msg trans USING(message_id) "
	. "WHERE orig.translations < $numtrans$cond "
//	. "AND orig.language_code != trans.language_code "
	. "AND orig.language_code IN ('" . join("','",$can_trans_from)."') "
	. "ORDER BY msgid" );

if( !$res ) print db_query_error();

// need index on "translations".

$trmiss_count = 0;

function finalize() {
	global $currid, $misslang, $can_trans_i, $origlang, $trmiss;
	global $LANG_CI, $msgid, $trmiss_count;

	if( $currid ) {
		// now check which of the $origlang:$misslang[]
		// combinations the user can translate.
		reset($misslang);
		while(list($k,$v)=each($misslang)) {
			if( isset($can_trans_i["$origlang:$k"]) ) {
				$trmiss[$currid][] = "$origlang:$k";
				$trmiss_count ++;
			}
		}
	}
	$misslang = $LANG_CI;
	$currid = $msgid;
}


// I now get a list of existing translations.  Tick them off and see what's
// left over.
$trmiss = array();
$currid = '';
$misslang = array();
$origlang = '';
$msgid = '';
while( $trmiss_count < 50 && $row = db_fetch_array($res) ) {
	$msgid = $row['msgid'];
	if( $msgid != $currid ) {
		finalize();
	}
	$origlang = $row['o_lc'];
	unset($misslang[$row['t_lc']]);
}
finalize();
ksort($trmiss);


// now look for outdated translations that the user could translate
$res = db_query( "SELECT orig.message_id AS msgid,orig.language_code AS olc,trans.language_code AS tlc "
	. "FROM ".$db_prefix."msg orig, ".$db_prefix."msg trans "
	. "WHERE orig.message_id = trans.message_id "
	. "AND orig.language_code = trans.origlang "
	. "AND orig.version != trans.origversion "
	. "AND concat(orig.language_code,':',trans.language_code) IN "
	. "('".join("','",$can_trans)."')" );

if( !$res ) exit_dberror();

$trold=array();
while( $row = db_fetch_array($res) ) {
	$trold[$row['msgid']] = "$row[olc]:$row[tlc]";
}
asort($trold);

print "Results:<br>\n";
print "Messages that do not have $numtrans translations "
	. "(limited to the first 50):<br>\n<ul>\n";
$t_link = get_link('account:trans_one');

reset($trmiss);
while(list($k,$v)=each($trmiss)) {
	print "<li> $k";
	$url = " <A href=\"$t_link?message_id=".urlencode($k)."&fromto=";
	for($i=0;$i<count($v);$i++)
		print $url . urlencode($v[$i]) . "\">$v[$i]</A> ";
	print "\n";
}
print "</ul>\n<br>\n";

print "Messages that have outdated translations:<br>\n<ul>\n";
reset($trold);
while(list($k,$v)=each($trold)) {
	print "<li> $k <A href=\"$t_link?message_id=".urlencode($k)
		."&fromto=$v\">$v</A>\n";
}
print "</ul>\n<br>\n";

site_footer();

?>
