<?php
# When a user creates an account, he gets an e-mail containing
# a code with which he can activate the new account.  This is done to ensure
# the validity of the e-mail address.
# Here the code ("confirm_hash") is validated and the user is activated.
#
# $Id: verify.php,v 1.2 2001/11/10 12:39:14 sf Exp $

include '../include/pre.php';
include "$INCDIR/newsession.php";	// session_login_valid


/* RC: 0=ok  1=not valid  2=database error */
function verify_login_valid() {
	global $form_loginname, $form_pw, $confirm_hash, $db_prefix;

	if (!$form_loginname) {
		set_error(gm('verify:invuser'));
		return 1;
	}

	// find the user.
	$res = db_query("SELECT user_id,password,status "
		. "FROM ".$db_prefix."user "
		. "WHERE user_name='$form_loginname'");
	if(!$res)
		return 2;
	if(db_numrows($res) < 1) {
		set_error(gm('verify:invuser'));
		return 1;
	}
	$user = db_fetch_array($res);
	$user_id = $user['user_id'];

	// verify password
	if($user['password'] != md5($form_pw)) {
		set_error(gm('verify:invuser'));
		return 1;
	}

	// user must be pending.
	if($user['status'] != 'P') {
		set_error(gm('verify:notpending'));
		return 1;
	}

	// get the userpending entry
	$res = db_query("SELECT * "
		. "FROM ".$db_prefix."userpending "
		. "WHERE user_id=$user_id");
	if( !$res ) return 2;
	if (db_numrows($res) < 1) {
		set_error(gm('verify:notfound'));
		return 1;
	}
	$userpending = db_fetch_array($res);

	if (strcmp($confirm_hash,$userpending['confirm_hash'])) {
		set_error( gm('verify:invalidconfirm') );
		return 1;
	}

	// OK so far.
	return session_login_valid($form_loginname,$form_pw,1);
}

// ---- main ----

authenticate('verify');
if(!isset($confirm_hash)) {
	$no_ch=1;		// no confirm hash
}

if( isset($Login) && isset($confirm_hash) ) {
	$rc = verify_login_valid();

	if( $rc == 2 )
		exit_error('ERROR',db_query_error() );

	if( $rc == 0 ) {
		$res = db_query("UPDATE ".$db_prefix."user "
			. "SET status='A' "
			. "WHERE user_id='$USER[user_id]'");
		if(!$res)
			exit_error('ERROR',$db_query_error );

		$res = db_query("DELETE FROM ".$db_prefix."userpending "
			. "WHERE user_id='$USER[user_id]'" );
		if(!$res)
			exit_error('ERROR',$db_query_error );

		session_redirect(get_link('first_login'));
	}
}

// not OK
site_header('verify');

$error_msg = error_get_string();
if( $error_msg ) {
	$error_msg = "<p><font color=\"#ff0000\">$error_msg</font></p>";
}

print gm('verify:mainmessage');
print $error_msg . "\n";

if(!isset($form_loginname))$form_loginname='';
if(!isset($form_pw)) $form_pw='';
if(!isset($confirm_hash)) $confirm_hash = '';

print '<form action="'.$PHP_SELF.'" method="post">

<p>'.gm('strings:username').':<br>
<input type="text" name="form_loginname" value="'.$form_loginname.'"></p>

<p>'.gm('strings:password').':<br>
<input type="password" name="form_pw" value="'.$form_pw.'"></p>
';

if(isset($no_ch)) {
	print '<p>'.gm('verify:strategies')."</p>\n";
	print "<p>".gm('verify:confirm_hash').":<br>\n";
	print '<INPUT type="text" name="confirm_hash" value="'.$confirm_hash.'"></p>'."\n";
	print '<INPUT type="hidden" name="no_ch" value="1">'."\n";
} else {
	print '<INPUT type="hidden" name="confirm_hash" value="'.$confirm_hash.'">'."\n";
}
print '<p><input type="submit" name="Login" value="Login"></p>
</form>'."\n";

site_footer();
?>
