<?php
# Delete a category.
# $Id: catdel.php,v 1.2 2001/11/09 22:42:18 sf Exp $

include '../include/pre.php';
include 'catutil.php';

// recursively delete a projectcat (depth first).
// note: you still have to decrement the subcat_count of the parent node of
// node $projectcat_id.
function projectcat_del($projectcat_id) {
	global $delete_result;

	// delete all children
	$res = db_query( "SELECT projectcat_id "
		. "FROM ".$db_prefix."projectcat "
		. "WHERE parent_id=$projectcat_id" );
	if( !$res ) return db_query_error();
	$msg = '';
	while( $row = db_fetch_array($res) ) {
		$msg .= projectcat_del($row['projectcat_id']);
	}
	if( $msg ) return $msg;

	// delete all references to this node
	$res = db_query( "DELETE FROM ".$db_prefix."projectcat_project "
		. "WHERE projectcat_id=$projectcat_id" );
	if( !$res ) return db_query_error();

	// delete all texts of this node
	text_del(array('projectcat_name','projectcat_description'),$projectcat_id,'');

	// delete the node itself
	$res = db_query( "DELETE FROM ".$db_prefix."projectcat "
		. "WHERE projectcat_id=$projectcat_id" );
	if( !$res ) return db_query_error();

	return '';
}

// returns '' if OK, else error message.
function do_delete($projectcat_id) {

	// find parent id
	$res = db_query( "SELECT parent_id "
		. "FROM ".$db_prefix."projectcat "
		. "WHERE projectcat_id=$projectcat_id" );
	if( !$res ) return db_query_error();
	if( db_numrows($res) < 1 ) return "Node $projectcat_id doesn't exist.";
	$parent_id = db_result($res,0,'parent_id');

	// delete this node and all subnodes
	$del_result = projectcat_del($projectcat_id);

	// update the subcat count
	projectcat_csc($parent_id,-1);

	return '';
}


$del_result = '';
if( isset($Delete) && isset($projectcat_id) && $projectcat_id ) {
	authenticate('catdel');
	$del_result = do_delete($projectcat_id);
	if( $del_result == '' )
		session_redirect(get_link('catlist'));
}

site_header('catdel');
if( $del_result ) {
	print "<p>$del_result</p>\n";
}
$node_name = projectcat_name($projectcat_id);
?>

<b>Do you really want to delete the node <?php print $node_name; ?>
 <font color="#ff0000">and all subnodes</font>?</b>

<a href="<?php print $PHP_SELF; ?>?projectcat_id=<?php print $projectcat_id; ?>&Delete=1">[DELETE]</a>

<?php site_footer(); ?>
