<?php
# Edit a category.
# $Id: catedit.php,v 1.2 2001/11/09 22:46:05 sf Exp $

// to edit as well:
//  projectcat_id set && submit -> update
//  projectcat_id not set && submit -> insert
//  projectcat_id set -> fetch values
//

include '../include/pre.php';
include 'catutil.php';


// Determine the toplevel node of the given node.  This means to simply read
// the "root_parent_id".
function projectcat_root($id,&$path) {
	// error_log("projectcat_root: id=$id",0);
	$path='';
	if( !$id ) return 0;
	$res = db_query("SELECT root_parent_id,path "
		. "FROM ".$db_prefix."projectcat "
		. "WHERE projectcat_id=$id");
	if( !$res ) return 0;
	if( db_numrows($res) < 1 ) return -1;
	$row = db_fetch_array($res);
	$path = $row['path'];
	return $row['root_parent_id'];
}


function do_submit() {
	global $lang_list, $projectcat_name, $projectcat_description;
	global $form_parent, $submit_result, $projectcat_id;

	// which languages are entered?  Reject partly entered entries.
	$langs = explode(' ',$lang_list);
	$valid = array();
	while( list($k,$lc) = each($langs) ) {
		if( $lc == '' )
			continue;
		if( $projectcat_name[$lc] ) {
			$valid[] = $lc;
			continue;
		}
		if( $projectcat_name[$lc] || $projectcat_description[$lc] )
			$submit_result .= gm('catedit:partly',array('lang'=>$lc));
	}

	if( $submit_result )
		return;

	if( !count($valid) ) {
		$submit_result .= gm('catedit:none');
		return;
	}

	// what is the root of the given parent?
	$updating = ($projectcat_id) ? 1 : 0;
	$newroot = projectcat_root($form_parent,$path);

	if( $newroot == -1 ) {
		error_log("projectcat_root returned $newroot",0);
		$submit_result = "The parent node $form_parent does not exist: $newroot";
		return;
	}

	if( $form_parent ) {
		if( $path != '' ) $path .= ','; // should always be true.
		$path .= $form_parent;
	} else {
		$form_parent = '0';
		$path = '0';
	}

	if( !$projectcat_id ) {
		$res = db_query( "INSERT INTO ".$db_prefix."projectcat"
			. "(parent_id,root_parent_id,path) VALUES"
			. "($form_parent,$newroot,'$path')" );
		if( !$res ) {
			$submit_result = db_query_error();
			return;
		}
		$projectcat_id = db_insertid();

		// root is self -> update this field to $projectcat_id, which wasn't
		// known before.
		if( $newroot == 0 ) {
			$res = db_query( "UPDATE ".$db_prefix."projectcat "
				. "SET root_parent_id=$projectcat_id "
				. "WHERE projectcat_id=$projectcat_id" );
			if( !$res ) print db_query_error();
		}
		projectcat_csc($form_parent,1);
	} else {
		// update
		// XXX if the parent changes, do the following:
		// - decrement the subcat count of the old parent
		// - increment the subcat count of the new parent
		// - change the parent_id of this node
		// - fix this node and subnodes: root_parent_id, path
	}

	reset($valid);
	while( list($k,$lc) = each($valid) ) {

		// text_set('projectcat_shortname',$projectcat_id,$lc,$projectcat_shortname[$lc],$updating);
		text_set('projectcat_name',$projectcat_id,$lc,$projectcat_name[$lc],$updating);
		if( $projectcat_description[$lc] )
			text_set('projectcat_description',$projectcat_id,$lc,$projectcat_description[$lc],$updating);
	}

	session_redirect(get_link('catlist'));
}

?><?php
// ------------ start --------------

$submit_result = '';
if( isset($Submit) && isset($lang_list) ) {
	do_submit();
} elseif( isset($projectcat_id) && $projectcat_id ) {
	// edit?
	$res = db_query( "SELECT root_parent_id "
		. "FROM ".$db_prefix."projectcat "
		. "WHERE projectcat_id=$projectcat_id" );
	$root_parent_id = db_result($res,0,'root_parent_id');

	// need a map of field_id -> field_name.
	$FIELD_NAME=array();
	reset($FIELD_ID);
	while(list($k,$v)=each($FIELD_ID))
		$FIELD_NAME[$v] = $k;

	// get the names of this project in all languages.
	$res = text_get(array('projectcat_name','projectcat_description'),
		$projectcat_id,'',2);
	reset($res);
	while( list($k,$v) = each($res) ) {
		list($fid,$lc) = explode(':',$k);
		$v = htmlspecialchars($v);
		eval( "\$$FIELD_NAME[$fid]['$lc'] = \"$v\";" );
	}
}

// Note: when projectcat_id is set, I assume that all the other fields
// (projectcat_shortname[] etc.) are set too - they are *not* requeried.

if( !isset($projectcat_id) ) $projectcat_id=0;
$title = ($projectcat_id ? 'catedit' : 'catadd');
site_header($title);


if( $submit_result )
	print "<p><b>$submit_result</b></p>\n";
print gm($projectcat_id?'catedit:edit':'catedit:add');

if( $projectcat_id ) {
	print "<p><a href=\"catdel.php?projectcat_id=$projectcat_id\">[Delete]</a></p>\n";
}

print "<form action=\"$PHP_SELF\" method=\"post\">\n";
print "<table width=\"100%\">\n"
	. "<colproject><col width=\"1*\"><col width=\"5*\"></colproject>\n";

print "<tr>\n"
	. " <td>" . gm('catedit:parent') . "</td>\n"
	. " <td><SELECT name=\"form_parent\">\n"
	. "  <OPTION value=\"0\">Root</OPTION>\n";

// Generate list of possible parents.  If a project has no name in one of the
// languages in $LANG, then it will *not* show up!
$res = text_get('projectcat_name','',$LANG);
asort($res);
if( !isset($form_parent) ) $form_parent = 0;
while( list($id,$name) = each($res) ) {
	print '  <OPTION value="'
		.$id.'"'.($id == $form_parent ? ' SELECTED' : '')
		. ">$name</OPTION>\n";
}
print " </SELECT></td>\n</tr>\n";


// $t_sn = gm('catedit:shortname');
$t_fn = gm('catedit:fullname');
$t_d = gm('catedit:desc');
$t_p = gm('catedit:parent');
$langs = "";

// key=language_code, value=name, sorted by name.
$lang_names = lang_table();

while( list($lc,$lang_name) = each($lang_names) ) {
	$langs .= "$lc ";
	// if( !isset($projectcat_shortname[$lc]) ) $projectcat_shortname[$lc]='';
	if( !isset($projectcat_name[$lc]) ) $projectcat_name[$lc]='';
	if( !isset($projectcat_description[$lc]) ) $projectcat_description[$lc]='';
	print
	  "<tr><th colspan=2 align=\"center\">$lang_name</th></tr>\n"
//	. "<tr>\n <td>$t_sn</td>\n"
//	. " <td><input type=\"text\" name=\"projectcat_shortname[$lc]\" value=\"$projectcat_shortname[$lc]\"></td>\n</tr>\n"
	. "<tr>\n <td>$t_fn</td>\n"
	. " <td><input type=\"text\" name=\"projectcat_name[$lc]\" value=\"$projectcat_name[$lc]\"></td>\n</tr>\n"
	. "<tr>\n <td>$t_d</td>\n"
	. " <td><input type=\"text\" name=\"projectcat_description[$lc]\" value=\"$projectcat_description[$lc]\"></td>\n</tr>\n";
}
print "</TABLE>\n";
print "<input type=\"hidden\" name=\"lang_list\" value=\"$langs\">\n";
print "<input type=\"hidden\" name=\"projectcat_id\" value=\"$projectcat_id\">\n";

?>
<br><input type="submit" name="Submit" value="Submit">
</form>

<?php site_footer(); ?>
