<?php
// Edit the contact types available for organisations.
// This is very similar to langedit.php
// - Add: adds a new type and goes into edit mode
// - Edit: enter the language's name in all languages.
// - Delete: but only if there's no contact of that type.
# $Id: editoct.php,v 1.2 2001/11/09 22:51:12 sf Exp $

include '../include/pre.php';
include "$INCDIR/buildvars.php";

authenticate('admin:editoct');

$result = '';

// Add a new ct?
if( isset($Add) ) {
	$res = db_query( "INSERT INTO ".$db_prefix."orgcontacttype VALUES('')" );
	if( !$res ) {
		$result = db_query_error();
	} else {
		$oct_id = db_insertid();
	}
}

// Check the whole DB for references to this language.
function oct_used($oct_id)
{
	global $result;

	$res = db_query( "SELECT COUNT(*) AS cnt "
		. "FROM ".$db_prefix."orgcontact "
		. "WHERE contacttype_id=$oct_id" );
	if( !$res ) { $result .= db_query_error(); return 1; }
	$cnt = db_result($res,0,'cnt');
	if( $cnt <> 0 ) {
		$result .= "<P>The contact type $oct_id is still being used.</P>\n";
		return 1;
	}

	// not used.
	return 0;
}

// Update?
if( isset($Update) && $oct_id ) {
	reset($LANG_CI);
	while( list($lc,$id) = each($LANG_CI) ) {
		if( $form[$lc] ) {
			text_set('orgcontacttype_name',$oct_id,$lc,$form[$lc],1);
		} else {
			// Note: text_del is also called for fields that
			// *were* empty, so ignore errors.
			text_del('orgcontacttype_name',$oct_id,$lc);
		}
	}
	// go to overview mode.
	$oct_id = '';
}

// Delete?  But only if it isn't used.	Don't check that this OCT really
// exists...
if( isset($Delete) && $oct_id ) {
	if( !oct_used($oct_id) ) {
		$res = db_query( "DELETE FROM ".$db_prefix."orgcontacttype "
			. "WHERE orgcontacttype_id=$oct_id" );
		if( !$res ) $result .= db_query_error();
		text_del('orgcontacttype_name',$oct_id,'');
		$oct_id='';
	}
}

// Edit one language
if( isset($oct_id) && $oct_id ) {

	site_header('admin:editoct');
	if( $result ) print "<p>$result</p>\n";

	print "<p>Contact Type <b>$oct_id</b></p>\n";
	print "<p>Please enter the names in each of the languages.</p>\n";

	// key=language, value=text
	$names = text_get('orgcontacttype_name',$oct_id,'',2);
	reset($names);

	$lang_table = lang_table();

	print "<FORM action=\"$PHP_SELF\" method=\"post\">\n<UL>\n";
	while( list($lc,$lang_name) = each($lang_table) ) {
		$name = isset($names[$lc]) ? $names[$lc] : '';
		print "<LI>$lang_name <INPUT type=\"text\" name=\"form[$lc]\" value=\"$name\">\n";
	}
	print "</UL>\n".'<INPUT type="submit" name="Update" value="Update">';
	print '<INPUT type="submit" name="Delete" value="Delete">';
	print '<INPUT type="hidden" name="oct_id" value="'.$oct_id.'">';
	print "\n</FORM>\n";
	site_footer();
	exit;
}

// List of contact types
site_header('admin:editoct');
if( $result ) print "<p>$result</p>\n";
print "List of Contact Types:\n<ul>\n";
$res = db_query( "SELECT * FROM ".$db_prefix."orgcontacttype" );
if( !$res ) print db_query_error();
$oct = array();
while( $row = db_fetch_array($res) )
	$oct[] = $row['orgcontacttype_id'];
ksort($oct);

$names = text_get('orgcontacttype_name','',$LANG);

while( list($foo,$id) = each($oct) ) {
	if( !isset($names[$id]) ) $names[$id] ='';
	print "<li><b>$id</b> $names[$id] <a href=\"$PHP_SELF?oct_id=$id\">[Edit]</a>\n";
}
print "</ul>\n";

?>

<FORM action="<?php print $PHP_SELF; ?>" method=\"get\">
<INPUT type="submit" name="Add" value="Add New Contact Type">
</FORM>

<?php site_footer(); ?>
