<?php
# Edit the Languages the site is available in.  You can:
# - Add: specify the two letter code.
# - Edit: enter the language's name in all languages.
# - Delete: but only if there's nothing on the site in this language.
# $Id: langedit.php,v 1.2 2001/11/10 09:45:22 sf Exp $

include '../include/pre.php';
include "$INCDIR/buildvars.php";

authenticate('langedit');

$result = '';

// Add a new language?
if( isset($Add) && $lc ) {
	$res = db_query( "INSERT INTO ".$db_prefix."language(language_code) "
		. "VALUES('$lc')" );
	if( !$res ) {
		$result = db_query_error();
	} else {
		// rebuild LANG_CI and LANG_IC tables in var.php
		$result .= build_maps();
		$new_nr = db_insertid();
		$LANG_IC[$new_nr] = $lc;
		$LANG_CI[$lc] = $new_nr;
	}
	$lc = '';
}

// Check the whole DB for references to this language.
function lang_used($lc)
{
	global $result;

	$tables = array('text','project_language','message');
	while( list($i,$name) = each($tables) ) {
		$res = db_query( "SELECT COUNT(*) AS cnt "
			. "FROM ".$db_prefix."$name "
			. "WHERE language_code='$lc'" );
		if( !$res ) { $result .= db_query_error(); return 1; }
		$cnt = db_result($res,0,'cnt');
		if( $cnt <> 0 ) {
			$result .= "<P>The language $lc is still being used in the table $name</P>\n";
			return 1;
		}
	}

	// not found anywhere.
	return 0;
}

// Update?
if( isset($Update) && $lc ) {
	$l_id = $LANG_CI[$lc];
	reset($LANG_CI);
	while( list($k,$id) = each($LANG_CI) ) {
		if( $form[$k] ) {
			text_set('language_name',$l_id,$k,$form[$k],1);
		} else {
			// Note: text_del is also called for fields that
			// *were* empty, so ignore errors.
			text_del('language_name',$l_id,$k);
		}
	}
	$lc = '';
}

// Delete?
// First check that this language is used *nowhere*.  The tables that
// currently include references to languages are:
//	- text
//	- project_language
//	- message
if( isset($Delete) && $lc ) {
	if( isset($LANG_CI[$lc]) ) {
		if( !lang_used($lc) ) {
			$l_id = $LANG_CI[$lc];
			if($l_id) text_del( 'language_name',$l_id );
			$res = db_query( "DELETE FROM ".$db_prefix."language "
				. "WHERE language_code='$lc'" );
			if( !$res ) $result .= db_query_error();
			unset($LANG_CI[$lc]);
			unset($LANG_IC[$l_id]);
			$lc = '';
			// rebuild LANG_CI and LANG_IC tables in var.php
			$result .= build_maps();
		}
	} else {
		$result .= "<P>Can't delete language $lc - doesn't exist</P>\n";
		$lc = '';
	}
}

// Edit one language
if( isset($lc) && $lc ) {

	site_header('langedit_lang');
	if( $result ) print "<p>$result</p>\n";

	print "<p>Language <b>$lc</b></p>\n";
	print "<p>Please enter the language names in each of the languages.</p>\n";

	$l_id = $LANG_CI[$lc];
	$names = text_get('language_name',$l_id,'',2);
	reset($names);

	// key=object id:language
	// value=text
	print "<form action=\"$PHP_SELF\" method=\"post\">\n<ul>\n";
	ksort($LANG_CI);
	reset($LANG_CI);
	while( list($lang_code,$lang_id) = each($LANG_CI) ) {
		$name = isset($names[$lang_code]) ? $names[$lang_code] : '';
		print "<li>$lang_code <input type=\"text\" name=\"form[$lang_code]\" value=\"$name\">\n";
	}
	print "</ul>\n".'<input type="submit" name="Update" value="Update">';
	print '<input type="submit" name="Delete" value="Delete">';
	print '<input type="hidden" name="lc" value="'.$lc.'">';
	print "\n</form>\n";
	site_footer();
	exit;
}

// List of languages
site_header('langedit');
if( $result ) print "<p>$result</p>\n";
print "List of Languages:\n<ul>\n";
$names = text_get('language_name','',$LANG);

asort($LANG_IC);
reset($LANG_IC);
while( list($id,$lc) = each($LANG_IC) ) {
	if( !isset($names[$id]) ) $names[$id] ='';
	print "<li><b>$lc</b> $names[$id] <a href=\"$PHP_SELF?lc=$lc\">[Edit]</a>\n";
}
print "</ul>\n";

?>

<FORM action="<?php print $PHP_SELF; ?>" method=\"get\">
Add Language: <input type="text" name="lc" size=5>
<input type="submit" name="Add">
</FORM>

<?php site_footer(); ?>
