<?php
// History:
// 10-06-2000	no version is version 1 by default now.
// 15-06-2000	insert into the database instead of writing .php files
// 16-06-2000	all files are in /tr/
// 16-06-2000	enhanced message ID line format
// 19-06-2000	no distinction between original and translation file
# $Id: langimport.php,v 1.5 2001/11/11 22:22:42 sf Exp $

include '../include/pre.php';
include 'langtool.php';

$odir = "$BASEDIR$tr_dir";

$just_testing = 0;		// don't really do anything to the DB

// Normally, if a message with the same version already exists in the DB, it
// is left alone.  With $force_update, these are updated as well.  Older
// versions are overwritten anyway, and newer version are never overwritten.
$force_update = 0;


if( !isset($BuildButton) ) {
	site_header('langimport');
?><br>

<h2> Welcome to the language file Importer.</h2>

<p>
You can <b>import</b> translation files <b>into the database</b>.
Please specify the module ID to be imported (as a regular expression).
No entry means <i>all</i> modules.
</p>

<p>
Note: when a message already exists in the database, it will only be updated
(overwritten) when the one to be imported has a higher version number.
</p>

<form action="langimport.php" method="post">
<input type=text name="form_fname" size=40>
<input type="submit" name="BuildButton" value="Build">
</form>
<?php
	site_footer();
	exit;
}

site_header('langbuildresult');

$count = array();

// Do this first, because if it doesn't work, nothing will.
$old_dir = getcwd();
if (!chdir($odir))
	exit_error('ERROR',"<H1>Can't chdir to $odir.</H1>\n");



if ($form_fname == '')
	$form_fname = '.*';

function trans_clear() {
	global $translations;
	$translations = array();
}

// Note to change the translation count of one message/lang.
function trans_delta($msgid,$origlang,$delta) {
	global $translations;
	$key = "$msgid.$origlang";
	if( !isset($translations[$key]) )
		$translations[$key] = $delta;
	else
		$translations[$key] += $delta;
}

// Perform all the necessary updates.
function trans_execute() {
	global $translations, $just_testing, $count, $db_prefix;

	ksort($translations);
	while(list($k,$delta)=each($translations)) {
		if( $delta == 0 )
			continue;
		if( $delta > 0 )
			$delta = "+$delta";
		list($msgid,$lang) = explode('.',$k);

		$sql = "UPDATE ".$db_prefix."msg "
			. "SET translations=translations$delta "
			. "WHERE message_id='$msgid' "
			. "AND language_code='$lang'";

		if( $just_testing ) {
			print $sql . "<br>\n";
		} else {
			$res = db_query( $sql );
			if( !$res ) { print db_query_error(); return; }
		}
		$count['update-trcount'] ++;
	}
}

?><?php

// Write an original message to the DB.  This is what is done all the time as
// the programmer updates his messages -- unless the programmer inserts his
// new messages directly into the DB.
function write_one( $msgid, &$text, $lang, $version, $origlang, $origversion ) {
	global $count, $force_update, $just_testing, $db_prefix;
	
	// does that already exist?
	$res = db_query( "SELECT version,origlang "
		. "FROM ".$db_prefix."msg "
		. "WHERE message_id = '$msgid' "
		. "AND language_code = '$lang'" );
	if( !$res ) { print db_query_error(); return; }
	$count['select'] ++;

	// the convention is for originals to set "origlang" to '' and
	// origversion to 0.

	if( $lang == $origlang ) {
		$origlang = '';
		$origversion = 0;
	}

	// new?
	if( db_numrows($res) == 0 ) {
		$t = $origlang ? 100 : 0;
		$sql = "INSERT INTO ".$db_prefix."msg(message_id,language_code,"
			. "translations,version,origlang,origversion,txt) "
			. "VALUES ('$msgid','$lang',$t,$version,'$origlang',"
			. "$origversion,'$text')";
		if( $just_testing ) {
			print "$sql<br>\n";
		} else {
			$res = db_query( $sql );
			if( !$res ) { print db_query_error(); return; }
		}
		$count['insert'] ++;

		// If it's a translation, note to increase the
		// translation-count of the original later, which may not have
		// been insertd yet.
		if( $origlang )
			trans_delta($msgid,$origlang,+1);

		return;
	}

	// already exists; check version
	$row = db_fetch_array( $res );
	$count['fetch']++;
	if( $row['version'] > $version ) {
		print "$msgid: newer version in database.<br>\n";
		$count['newer'] ++;
		return;
	}

	// same version - nothing to do.
	if( $row['version'] == $version && !$force_update ) {
		$count['same'] ++;
		return;
	}

	// the version in the DB is outdated, update.
	$sql = "UPDATE ".$db_prefix."msg SET version='$version',"
		. "origlang='$origlang',origversion=$origversion,"
		. "txt='$text' "
		. "WHERE message_id='$msgid' "
		. "AND language_code='$lang'";
	if( $just_testing ) {
		print "$sql<br>\n";
	} else {
		$res = db_query( $sql );
		if( !$res ) { print db_query_error(); return; }
	}
	$count['update'] ++;

	// the orig language might have changed...
	if( $row['origlang'] != $origlang ) {
		trans_delta($msgid,$row['origlang'],-1);
		trans_delta($msgid,$origlang,+1);
	}
}

?><?php

function process_message($msgid,$version,&$text,$lang,$origlang,$modid,$origversion) {

	if( !$msgid && !$text )
		return;

	if( !$msgid ) {
		print "<b>Error</b> Missing msgid.<br>\n";
		return;
	}
	if( !$text ) {
		print "<b>Error</b> Missing text for $msgid.<br>\n";
		return;
	}

	// msgid for the database actually includes the moduleid.
	$msgid = "$modid:$msgid";

	// prepare $text for insertion into the DB
	$text = str_replace("'","\\'",$text);

	// remove the newlines at the end & beginning
	trim_text($text);

	write_one($msgid,$text,$lang,$version,$origlang,$origversion);
}


// Read one translation file and output all valid messages.
function process_translation($modid,$lang) {

	print "<li>$lang\n";
	$fd = fopen( $modid . '.' . $lang, 'r' );
	if( !$fd ) {
		print " - <b>can't open</b>\n";
		return;
	}

	$msgid = '';
	$text = '';
	$version = '';
	$origversion = 1;
	$origlang = $lang;

	while( $line = fgets($fd,500) ) {

		// comment?
		if( substr($line,0,1) == '#' )
			continue;

		// start of new message?
		if( substr($line,0,1) == '*' ) {
			process_message($msgid,$version,$text,$lang,$origlang,$modid,$origversion);
			$text = '';
			list($msgid,$version,$origlang,$origversion)
				= parse_msgid($line,$lang);
			continue;
		}

		// before the start of the first message?
		if( $msgid == '' )
			continue;

		// reading a message - append to buffer.
		$text .= $line;
	}
	fclose( $fd );

	// Flush the last message.  Same code as above.
	process_message($msgid,$version,$text,$lang,$origlang,$modid,$origversion);
	$text = '';
}

?><?php

// Process one module.
function process_module($modid,$tr_list) {

	print $modid . "\n";

	// clear the table of translation count delta information
	trans_clear();

	print "<ul>\n";
	reset($tr_list);
	while( list($lang,$v) = each($tr_list) )
		process_translation($modid,$lang);

	// execute any update statements that may be required to keep the
	// "translations" field up to date.
	trans_execute();
	print "</ul>\n";
}


?><?php



// ---- main, continued -----
// find all matching files.

$d = opendir(".");
if( !$d ) exit_error("ERROR","Can't read directory $odir.");

$count_files = 0;
$modules = array();
while( $fname = readdir($d) ) {

	// catch "." and "..", as well as hidden files.
	if( substr($fname,0,1) == '.' )
		continue;

	// Only files in the form "module.lang" are acceptable, i.e. it must
	// contain a ".".  What prompted this update: "CVS" subdir there...
	if( !strstr($fname, "."))
		continue;

	// split into module name and language code
	list($modid,$lc) = explode('.',$fname);

	// match (but only the module name)
	if( !ereg($form_fname,$modid) )
		continue;

	$modules[$modid][$lc] = 1;
	$count_files ++;
}
closedir($d);

print "Found $count_files individual files for ".count($modules)." modules to process.<br>";

$count['select'] = $count['insert'] = $count['update'] = $count['same'] = 0;
$count['newer'] = $count['nooriginal'] = $count['update-trcount'] = 0;
$count['fetch'] = 0;


reset($modules);
while( list($modid,$v) = each($modules) ) {
	process_module($modid,$v);
}

// show statistics
print "<hr><h2>Statistics</h2>\n<ul>\n";
reset($count);
while(list($k,$v)=each($count)) {
	if( $v )
		print "<li>$k: $v\n";
}
print "</ul>\n";

// Why this?  See langexport.php at the end.
chdir($old_dir);
site_footer();

?>
