<?php
# Accept or decline pending projects.
# $Id: pending-projects.php,v 1.4 2001/11/10 09:57:14 sf Exp $

include '../include/pre.php';
include "$INCDIR/account.php";
include "$INCDIR/project.php";
// require ('proj_email.php');

site_header('admin:projectpend');

if(!isset($action))
	$action='';

// Send an e-mail to all admins of a project (even though technically there is
// only one admin at this point).
function send_new_project_email($project_id) {
	global $sys_sitename, $sys_domain, $db_prefix;

	// get the project
	$res = db_query("SELECT * FROM ".$db_prefix."project "
		. "WHERE project_id=$project_id");
	if( !$res ) print db_query_error();
	if( db_numrows($res) < 1) {
		echo "Project [ $project_id ] does not exist. Shame on you, sysadmin.";
	}
	$project = db_fetch_array( $res );

	// get all admins of this project
	$res = db_query( "SELECT user_name,email,languages "
		. "FROM ".$db_prefix."user,".$db_prefix."user_project "
		. "WHERE ".$db_prefix."user.user_id=".$db_prefix."user_project.user_id "
		. "AND ".$db_prefix."user_project.project_id=$project_id "
		. "AND ".$db_prefix."user_project.p_admin=1" );
	if( !$res ) print db_query_error();

	if( db_numrows($res) < 1) {
		echo ("send_new_project_email: project [ $project_id ] does not seem to have any administrators.");
	}

	// send one email per admin (in his preferred language)
	while( $row = db_fetch_array($res) ) {
		$langs = explode(' ',$row['languages']);
		$name = text_get('project_name',$project_id,$langs);
		$name = $name[''];
		$subject = gm('newproject:msgsubject',
			array('site'=>$sys_sitename),$langs,1);
		$body = gm( 'newproject:msgbody',array(
			'site'=>$sys_sitename,
			'name'=>$name,
			'unixname'=>$project['unix_project_name']), $langs, 1 );

		mail($row['email'],$subject,$body,"From: noreply@$sys_domain");
	}
}

// project public choice
if( $action == 'activate' ) {

	// update the project flag to active
	$res = db_query("UPDATE ".$db_prefix."project "
		. "SET status='A' "
		. "WHERE project_id IN ($glist)");
	if( !$res ) print db_query_error();

	// DELETED from the SourceForge original: activate unix account

	// Now send the project approval emails
	$projects=explode(',',$glist);
	$count=count($projects);
	for ($i=0; $i<$count; $i++) {
		send_new_project_email($projects[$i]);
		usleep(250000);
	}

} elseif( $action == 'delete' ) {
	$res = db_query("UPDATE ".$db_prefix."project "
		. "SET status='D' "
		. "WHERE project_id='$project_id'");
	if( !$res ) print db_query_error();
}

// ------ list of pending projects ------
$res = db_query("SELECT * FROM ".$db_prefix."project "
	. "WHERE status='P'");
if( db_numrows($res) < 1 ) {
	print "There are no pending projects.";
	// this is just to clean out NAVPATH, not really necessary.
	// session_var_del('NAVPATH[project:main]');
	unset($SESSION_VAR['NAVPATH']['project:main']);
	// session_var_del('NAVPATH[project:members]');
	unset($SESSION_VAR['NAVPATH']['project:members']);
	site_footer();
	exit;
}

$ids = array();
while( $row = db_fetch_array($res) ) {
	$ids[] = $row['project_id'];
	$projects[$row['project_id']] = $row;
}

// get the (initial) language of the project
$res = db_query( "SELECT * FROM ".$db_prefix."project_language "
	. "WHERE project_id IN (" . join(',',$ids) . ")" );
if( !$res ) print db_query_error();

while( $row = db_fetch_array($res) ) {
	$projects[$row['project_id']]['language_code'] = $row['language_code'];
}

// key=project_id:field_id  value=text
$names = text_get(array('project_name','project_purpose'),$ids);
asort($names);
reset($names);
$f_name = $FIELD_ID['project_name'];
$f_purpose = $FIELD_ID['project_purpose'];
while( list($k,$name) = each($names) ) {
	list($fid,$gid) = explode(':',$k);
	if( $fid != $f_name )
		continue;

	$row = $projects[$gid];
	print "<H2>$name ($row[language_code])</H2>\n";
?> 
<P>
<A href="<?php print get_link("project:main") . "?project_id=$gid&NP=admin:projectpend"; ?>">[Edit Details]</A>
<A href="<?php print get_link("project:members") . "?project_id=$gid"; ?>">[View/Edit Members]</A>
<A href="<?php print "$PHP_SELF?action=activate&glist=$gid"; ?>">Activate</A>
<A href="<?php print "$PHP_SELF?action=delete&project_id=$gid"; ?>">Delete</A>
</P>

<P><B>Other Information</B></P>
Unix Project Name: <?php print $row['unix_project_name']; ?><br>
Submitted Description:
<p><font size="-1">
<?php print $names["$f_purpose:$gid"]; ?>
</font></p>
<HR>
<?php

}

// from here you can reach subpages of projectadmin.  Temporarily make this page
// the parent of projectadmin.
// session_var_set('NAVPATH[project:main]','admin:projectpend');	// unset in project/index.php

$SESSION_VAR['NAVPATH']['project:members'] = 'admin:projectpend';	// unset in admin/index.php
// session_var_set('NAVPATH[project:members]','admin:projectpend');	// unset in admin/index.php

site_footer();
?>
