<?php
# Show a list of projects.  Parameters on the URL are:
#	- $filter	show only projects whse name starts with $filter
#	- $status	show only projects in this status.
# $Id: projectlist.php,v 1.4 2001/11/11 00:01:03 sf Exp $

include '../include/pre.php';

authenticate('admin:projectlist');

$projects = array();	// key = project_id  value=array

// when looking for active projects, first get all (matching) names and
// afterwards filter out the non-active ones.

if(!isset($status) || $status == 'A') {

	// first, find matching names (all languages).
	$sql = "SELECT object_id,language_code,txt "
		. "FROM ".$db_prefix."text "
		. "WHERE field_id=$FIELD_ID[project_name]";

	// apply filter if given
	if (isset($filter) && $filter) {
		$sql .= " AND txt LIKE '$filter%'";
	}

	$sql .= " ORDER BY txt";
	$res = db_query( $sql );
	if (!$res)
		print db_query_error();

	while ($row = db_fetch_array($res)) {
		$pid = $row['object_id'];
		$ids[] = $pid;

		if( !isset($projects[$pid]) )
			$projects[$pid] = array();
		$projects[$pid]["$row[language_code]:title"] = $row['txt'];
	}

	// Remove all non-active projects.
	$res = db_query("SELECT project_id "
		. "FROM $db_prefix"."project "
		. "WHERE status != 'A'");
	while ($row = db_fetch_array($res))
		unset($projects[$pid]);
} else {
	// when looking for non-active projects, they are a minority.
	// BUT you need additional permission for this.
	if( !user_perm('projectadmin') && !user_perm('siteadmin') )
		exit_error("NO PERMISSION","You can't list projects in Status $status.");

	$projects = array();
	$res = db_query( "SELECT project_id FROM ".$db_prefix."project "
		. "WHERE status = '$status'" );
	while( $row = db_fetch_array($res) )
		$projects[$row['project_id']] = array();

	// get all the names (all languages).
	if(count($projects) > 0) {
		$names = text_get('project_name',array_keys($projects),$LANG,2);
		while(list($k,$v)=each($names)) {
			list($id,$lc)=explode(':',$k);
			$projects[$id]["$lc:title"] = $v;
		}
	}
}

site_header("admin:projectlist");

// show show the list.
reset($projects);
$project_link = get_link('project:main');
while(list($id,$v)=each($projects)) {
	reset($v);
	while(list($key,$text)=each($v)) {
		list($lang,$field) = explode(':',$key);
		if( $field == 'title') {
			print "<A href=\"$project_link?project_id=$id\">"
			. $text ."</A> ($lang)<br>\n";
		}
	}
}

site_footer();
?>
