<?php
// Show a list of users.  Normal users can also reach this page, but they can't
// change anything.

// Show a list of users and allow to activate/suspend/delete them, as well as
// edit their permissions (in edituser).
// Optionally limit the shown users to one project.  This might go away, as a
// project has its own user list with different permissions to set.

// parameters:
//	uf		user filter -> WHERE user_name LIKE '$uf%'
//	ac		action
//	user_id 	which user (for action)
//	project_id	when only members of that project are to be shown

# $Id: userlist.php,v 1.2 2001/11/10 10:01:28 sf Exp $

include '../include/pre.php';
include "$INCDIR/project.php";		// project_getname()

site_header('admin:userlist');

$admin = user_perm('siteadmin') || user_perm('useradmin');

function show_users_list($res) {
	global $uf, $MODE, $PHP_SELF, $admin;

	if( !$res ) {
		print db_query_error();
		return;
	}
	if( $admin ) {
		print "<P><b>Actions:</b> P=View Profile, E=Edit permissions, A=activate, D=delete, S=suspend<br>\n";
	} else {
		print "<P><b>Actions:</b> P=View Profile, V=View Permissions<br>\n";
	}

	if( $MODE == 'T' ) {
		print "<b>Key:</b> A=Active, D=Deleted, S=Suspended, *=Pending";
		$fmt=array('A1'=>'A ', 'A2'=>'',
			'D1'=>'D ', 'D2'=>'',
			'S1'=>'S ', 'S2'=>'',
			'P1'=>'* ', 'P2'>='');
	} else {
		print "<b>Key:</b> <B>Active</B> <I>Deleted</I> Suspended (*)Pending";
		$fmt=array('A1'=>'<b>','A2'=>'</b>',
			'D1'=>'<i>','D2'=>'</i>',
			'S1'=>'','S2'=>'',
			'P1'=>'*','P2'=>''
			);
	}
?>
</P>
<TABLE width=100% cellspacing=0 cellpadding=0 border=1>
<tr>
 <th width=20></th>
 <th width=20></th>
<?php if($admin) { ?>
 <th width=20></th>
 <th width=20></th>
 <th width=20></th>
 <?php } ?>
 <th width="99%"></th>
</tr>
<?php
	$c = $admin ? "E" : "V";

	$edit_link = get_link("admin:edituser");
	while ($usr = db_fetch_array($res)) {
		$st = $usr['status'];
		print "<TR>\n";
		print " <TD><A href=\"/developer/?form_dev=$usr[user_id]\">[P]</A></TD>\n";
		print " <TD><A href=\"$edit_link?uid=$usr[user_id]\">[$c]</A></TD>\n";
		if( $admin ) {
		print " <TD><A href=\"$PHP_SELF?ac=a&user_id=$usr[user_id]&uf=$uf\">[A]</A></TD>\n";
		print " <TD><A href=\"$PHP_SELF?ac=d&user_id=$usr[user_id]&uf=$uf\">[D]</A></TD>\n";
		print " <TD><A href=\"$PHP_SELF?ac=s&user_id=$usr[user_id]&uf=$uf\">[S]</A></TD>\n";
		}
		print " <TD>";
		print $fmt[$st.'1'] . $usr['user_name'] . $fmt[$st.'2'];
		print "</TD>\n</TR>\n";
	}
	print "</TABLE>";
}

// Administrative functions
if( !isset($ac) ) $ac='';
if( !$admin ) $ac='';

// Set this user to delete
if( $ac == 'd' ) {
	db_query("UPDATE ".$db_prefix."user "
		. "SET status='D' "
		. "WHERE user_id='$user_id'");
	echo '<H2>User Updated to DELETE Status</H2>';
}

// Activate an account
if( $ac == 'a' ) {
	db_query("UPDATE ".$db_prefix."user "
		. "SET status='A' "
		. "WHERE user_id='$user_id'");
	echo '<H2>User Updated to ACTIVE status</H2>';
}

// Suspend an account
if( $ac == 's' ) {
	db_query("UPDATE ".$db_prefix."user "
		. "SET status='S' "
		. "WHERE user_id='$user_id'");
	echo '<H2>User Updated to SUSPEND Status</H2>';
}

// Add a user to this project
if( $ac == 'add_to_project' ) {
	db_query("INSERT INTO ".$db_prefix."user_project(user_id,project_id) "
		. "VALUES ($user_id,$project_id)");
}

// --- Show list of users ---

print "<P>User List for Project: ";
if( !isset($project_id) || !$project_id ) {
	print "<b>All Projects</b></p>\n";
	if( isset($uf) ) $q = " WHERE user_name LIKE '$uf%'"; else $q='';
	$res = db_query("SELECT user_id,user_name,status "
		. "FROM ".$db_prefix."user$q "
		. "ORDER BY user_name");
	show_users_list( $res );
	site_footer();
	exit;
}

// --- Show list for one project ---

print "<b>" . project_getname($project_id) . "</b></p>\n";

$res = db_query("SELECT ".$db_prefix."user.user_id,user_name,status "
	. "FROM ".$db_prefix."user, ".$db_prefix."user_project "
	. "WHERE ".$db_prefix."user.user_id=".$db_prefix."user_project.user_id "
	. "AND ".$db_prefix."user_project.project_id=$project_id "
	. "ORDER BY user_name");
show_users_list( $res );

// Show a form so a user can be added to this project
?>
<hr>
<form action="<?php print $PHP_SELF; ?>" method="post">
<input type="hidden" name="ac" value="add_to_project">
<input name="user_id" type="text" value="">
Add User to Project (<?php print project_getname($project_id); ?>):
<br>
<input type="HIDDEN" name="project_id" VALUE="<?php print $project_id; ?>">
<input type="submit" name="Submit" value="Submit">
</form>

<?php site_footer(); ?>
