<?php
// Show a forum, allow to post.
// $Id: forum.php,v 1.5 2001/11/11 21:44:00 sf Exp $

include '../include/pre.php';
include 'futils.php';
include 'thutils.php';		// show_thread, thread_header

// 1. forum_id must be set
// 2. forum_id must refer to a valid forum (set FORUM)
// 3. if the forum is not public, user must be in project of forum (user_project)
authenticate('forum:forum');

// Get all names of the current forum.  key=lang  value=name
$forum_name = get_forum_name();

forum_header('forum:forum',$forum_name);


// Show all threads in the given forum.  Restrict to the languages in $LANG.
// Styles: f=flat, n=nested, t=threaded, u=ultimate
function show_threads($forum_id, $offset, $style, $max_rows) {
	global $LANG, $MODE, $colors;
	global $total_rows, $sys_datefmt;
	global $st_rownr, $db_prefix;

	// this is just in case $et is true.
	$st_rownr = 0;

	// threaded view
	if ($style == 't' || $style == 'u' || true) {

		// Get a sorted list of threads, along with the poster's names
		$sql = "SELECT user_name,message_id,thread_id,language_code,ts,subject "
			. "FROM $db_prefix"."message,$db_prefix"."user "
			. "WHERE forum_id=$forum_id "
			. "AND user_id=posted_by "
			. "AND followup_to=0 "
			. "AND language_code IN ('" . join("','",$LANG) . "') "
			. "ORDER BY ts DESC, subject ASC "
			. "LIMIT $offset,".($max_rows+1);

	$res = db_query ($sql);
	if (!$res)
		print db_query_error();
	$rows = db_numrows($res);
	if ($rows < 1)
		return "No Messages in forum #$forum_id\n";

	// use stripslashes on forum_name!
	thread_header();

	$counter=0;
	$thread_link = get_link('forum:thread');
	while ($counter++ < $max_rows && $row=db_fetch_array($res)) {
		$row_color = alt_row_color($counter);

		// expanded view -- show the whole thread instead of just the
		// header.
		if ($style == 't') {
			show_thread($row['thread_id'],0,1);
			continue;
		}

		// Build row for collapsed threads
		print "<TR BGCOLOR=\"$row_color\">"
			. '<TD><A href="'.$thread_link.'?thread_id='
			. $row['thread_id']
			. '">';
		if( $MODE != 'T' ) {
			html_image('ic/cfolder15.png');
			print ' ';
		}

		// See whether this message is new or not
		// if (get_forum_saved_date($forum_id) < db_result($result,$i,'date')) { $ret_val .= '<B>'; }
		
		print $row['subject'].'</A></TD>'.
			'<TD>'.$row['user_name'].'</TD>'.
			'<TD>'.date($sys_datefmt,$row['ts'])."</TD></TR>\n";
	}

/*
	// This code puts the nice next/prev.
	$ret_val .= '
			<TR BGCOLOR="#EEEEEE"><TD>';
	if ($offset != 0) {
		$ret_val .= '<FONT face="Arial, Helvetica" SIZE="3" STYLE="text-decoration: none"><B>
			<A HREF="javascript:history.back()">
			<B><IMG SRC="/images/t2.gif" HEIGHT=15 WIDTH=15 BORDER=0 ALIGN=MIDDLE> Previous Messages</A></B></FONT>';
	} else {
		$ret_val .= '&nbsp;';
	}

	$ret_val .= '</TD><TD>&nbsp;</TD><TD>';
	if (db_numrows($result) > $i) {
		$ret_val .= '<FONT face="Arial, Helvetica" SIZE=3 STYLE="text-decoration: none"><B>
			<A HREF="/forum/forum.php?et='.$et.'&offset='.($offset+$i).'&forum_id='.$forum_id.'">
			<B>Next Messages <IMG SRC="/images/t.gif" HEIGHT=15 WIDTH=15 BORDER=0 ALIGN=MIDDLE></A>';
	} else {
		$ret_val .= '&nbsp;';
	}
*/

	print "</TABLE>\n";
	return '';
	}
}


// ------- main --------

// if necessary, insert the new message 
if (isset($PostMessage)) {
	post_message($forum_id,$thread_id,$followup_to,$language_code,$subject,$body);
}

if (empty($offset) || $offset < 0)
	$offset = 0;

// If the user is not logged in, this simply sets these global variables.
user_var_add("forum_style", "n");
user_var_add("forum_max_rows", "25");

$styles = "ufnt";

if (isset($st) && strpos($styles, $st) !== false)
	$forum_style = $st;

if (!isset($forum_max_rows) || $forum_max_rows < 5)
	$forum_max_rows = 25;

user_var_sync();


// Allow the user to switch the style.
print "Forum style:";
for ($i=0; $i<strlen($styles); $i++) {
	$c = $styles[$i];
	if ($c == $forum_style)
		print " <B>$c</B>";
	else
		print " <A href=\"$PHP_SELF?forum_id=$forum_id&st=$c\">$c</A>";
}
print "<BR>\n";


// Show the forum in the current style.
print show_threads($forum_id, $offset, $forum_style, $forum_max_rows);

print "<P>&nbsp;</P>\n";

print "<DIV align=\"center\"><h3>Start a New Thread:</H3></DIV>\n";
show_post_form($forum_id);

forum_footer();

?>
