<?php
# Some utilities for forums.  Not to be used directly.
# $Id: futils.php,v 1.4 2001/11/11 21:43:07 sf Exp $

if(!isset($INCDIR)) {
	print "<HTML><BODY>This is just an include file!</BODY></HTML>\n";
	exit;
}
include "$INCDIR/project.php";

// get the project!
function forum_header($pagename,$title='') {
	site_header($pagename,$title);
	project_tabs('forums');	// Show icon bar unless it's a news forum
}

function forum_footer($params='') {
	if( !is_array($params) ) $params=array();
//	global $feedback;
//	html_feedback_bottom($feedback);
	site_footer($params);
}

// returns a new unique thread ID.
function forum_threadid() {
	global $db_prefix;

	$res = db_query( "INSERT INTO $db_prefix"."threadid VALUES('')" );
	if($res)
		return db_insertid($res);
	print db_query_error();
	exit;
}

// Create a new forum.  RC: 0=error, else forum ID
// The global variable $feedback gets some messages appended.
function forum_create_forum($project_id, $language_code, $forum_name, $p_read=1, $p_post=1, $create_default_message=1) {
	global $feedback, $LANG, $LANG_CI, $FIELD_ID, $db_prefix;

	// Check parameters
	if (!isset($forum_name) || !$forum_name) {
		$feedback .= " No forum name set. ";
		return 0;
	}

	if (!isset($language_code)) {
		$feedback .= " No language selected ";
		return 0;
	}

	if (!isset($LANG_CI[$language_code])) {
		$feedback .= " The language $language_code is invalid. ";
		return 0;
	}

	// does a forum by that name already exist?
	$f_forumname = $FIELD_ID['forum_name'];
	$res = db_query("SELECT COUNT(*) AS cnt "
		. "FROM $db_prefix"."text "
		. "WHERE field_id=$f_forumname "
		. "AND language_code='$language_code' "
		. "AND txt LIKE '$forum_name'");
	if (!$res) {
		$feedback .= " Database error: " . db_query_error();
		return 0;
	}
	$cnt = db_result($res,0,'cnt');
	if ($cnt != 0) {
		$feedback .= " A Forum with that name already exists. ";
		return 0;
	}

	// create the forum
	$res = db_query("INSERT INTO $db_prefix"."forum"
		. "(project_id,p_read,p_post) "
		. "VALUES ($project_id,$p_read,$p_post)" );
	if (!$res) {
		$feedback .= " Error Adding Forum: " . db_query_error();
		return 0;
	}
	$forum_id = db_insertid($res);

	$feedback .= " Forum Added ";

	text_set('forum_name', $forum_id, $language_code, $forum_name);

	if (!$create_default_message)
		return $forum_id;

	post_message($forum_id,
		0,		// thread_id
		0,		// followup_to
		$language_code,	// language_code
		gm('futils:welcome_subject',	// subject
			array('name'=>$forum_name),
			array($language_code,$LANG), 1),
		gm('futils:welcome_body',	// body
			array('name'=>$forum_name),
			array($language_code,$LANG), 1),
		1 );		// nocheck

	return $forum_id;
}

// Create a new message.  Referential integrity is *not* checked.
function post_message($forum_id, $thread_id, $followup_to, $language_code, $subject, $body, $nocheck=0) {
	global $USER, $FORUM, $db_prefix;

	if( !$nocheck ) {
		if( !$USER ) {
			print "<H3>You could post if you were logged in</H3>\n";
			return;
		}
		if( !$FORUM['p_post'] && !user_project_perm('') ) {
			print "<H3>As I said, this is a read-only forum!</H3>\n";
			return;
		}
	}
	if( !$forum_id )
		exit_error('Error','Trying to post without a forum ID');
	if (!$body || !$subject)
		exit_error('Error','Must include a message body and subject');
	if( !$thread_id )
		$thread_id = forum_threadid();
	if( !$followup_to )
		$followup_to = '0';

	$res = db_query( "INSERT INTO $db_prefix"."message"
		. "(forum_id,posted_by,followup_to,thread_id,ts,language_code,subject,body) "
		. "VALUES ($forum_id,$USER[user_id],$followup_to,$thread_id,".time().",'$language_code','".htmlspecialchars($subject)."','".htmlspecialchars($body)."')" );
	if( !$res ) { print db_query_error(); return 0; }
	$message_id = db_insertid($res);
	// forum_monitor($message_id);
	return $message_id;
}

?><?php
// Show a form that allows the user to post a new message, but only if he's
// permitted to do so.
function show_post_form($forum_id, $thread_id=0, $followup_to=0, $subject="") {

	global $PHP_SELF, $FORUM, $LANG, $et, $forum_names;

	// must be logged in
	if( !user_isloggedin() ) {
		print "<CENTER>\n";
		print "<H3><FONT color=\"red\">You could post if you were logged in</FONT></H3>\n";
		print "</CENTER>\n";
		return;
	}

	// must be member when posting is restricted
	if( !$FORUM['p_post'] && !user_project_perm('') ) {
		print "<CENTER>\n";
		print "<H3>This is a read-only forum.</H3>\n";
		print "</CENTER>\n";
		return;
	}

	$langs = lang_table();
// <INPUT type="hidden" name="et" value="<xx?php echo $et; ?xx>">

?>
<DIV align="center">
<FORM action="<?php echo $PHP_SELF; ?>" method="post">
<INPUT type="hidden" name="forum_id" value="<?php echo $forum_id; ?>">
<INPUT type="hidden" name="thread_id" value="<?php echo $thread_id; ?>">
<INPUT type="hidden" name="msg_id" value="<?php echo $followup_to; ?>">
<INPUT type="hidden" name="followup_to" value="<?php echo $followup_to; ?>">
<TABLE>
 <TR><TD><B><A name="_post">Language</A></B></TD>
 <TD><SELECT name="language_code">
<?php
	while( list($lc,$v) = each($forum_names) ) {
		$name = $langs[$lc];
		print "  <OPTION"; if($lc==$LANG[0]) print " SELECTED";
		print " value=\"$lc\">$name</OPTION>\n";
	}
?>
</SELECT>
</TD></TR>
<TR><TD><B>Subject:</TD><TD>
<INPUT TYPE="TEXT" NAME="subject" VALUE="<?php echo $subject; ?>" SIZE="15" MAXLENGTH="45">
</TD></TR>
<TR><TD><B>Message:</TD><TD></TR><TR><TD colspan=2>
<TEXTAREA NAME="body" VALUE="" ROWS="10" COLS="70" WRAP="SOFT"></TEXTAREA>
</TD></TR>
<TR><TD COLSPAN="2" ALIGN="MIDDLE">
<B><FONT COLOR="RED">HTML tags will display in your post as text</FONT></B>
<BR>
<INPUT type="submit" name="PostMessage" value="Post Comment">
</TD></TR></TABLE>
</FORM>
</DIV>
<?php
}

// get the forum name in the "best" language, but also determine in which
// languages the forum name is available.  This restricts in which languages
// you can post.
function get_forum_name() {
	global $LANG, $forum_id;
	global $forum_names;

	// get name in *all* languages.
	$forum_names = text_get('forum_name',$forum_id,$LANG,2);

	// pick the best
	reset($LANG);
	while(list($k,$v)=each($LANG)) {
		if( isset($forum_names[$v]) ) {
			$forum_name=$forum_names[$v];
			break;
		}
	}
	if( !isset($forum_name) ) {
		reset($names);
		list($k,$forum_name) = each($forum_names);
	}

	return $forum_name;
}

?>
