<?php
// List of forums for a project.
// $Id: index.php,v 1.3 2001/11/11 21:42:26 sf Exp $

include '../include/pre.php';
include 'futils.php';		// forum_header, forum_footer

authenticate('project:forums');

// Must be member of the project to be able to read restricted forums.
$onlypublic = '';
if (!user_project_perm(''))
	$onlypublic = " AND p_read=1";

// Build a table of IDs of existing forums of this project, then get all the
// names, sort them.
$res = db_query("SELECT forum_id,p_read,p_post "
	. "FROM $db_prefix"."forum "
	. "WHERE project_id=$project_id$onlypublic");
if (!$res)
	exit_dberror();

$project_name = project_getname($project_id);
forum_header('project:forums',"Forums for Project $project_name");

if (db_numrows($res) < 1) {
	echo '<H1>No forums found for '.project_getname($project_id)."</H1>\n";
	forum_footer();
	exit;
}

while ($row = db_fetch_array($res)) {
	$ids[] = $row['forum_id'];
	$p_post[$row['forum_id']] = $row['p_post'];
}

// The "3" means to get ONLY texts in the languages in $LANG.
$names = text_get('forum_name', $ids, $LANG, 3);
asort($names);

// If this is empty, then there aren't any forums in the languages $LANG.
if (count($names) == 0) {
	echo '<H1>No forums found for '.project_getname($project_id)
		." in any of your languages (".join(',',$LANG).")</H1>\n";
	forum_footer();
	exit;
}

$diff = count($ids) - count($names);
if ($diff) {
	print "<P><B>There are $diff forums that are not shown because "
		."they are only in languages you have not selected.</B></P>";
}

// get message counts
$res = db_query("SELECT forum_id,COUNT(*) AS cnt "
	. "FROM $db_prefix"."message "
	. "WHERE forum_id IN(" . join(',',$ids) . ") "
	. "GROUP BY forum_id");
if (!$res)
	print db_query_error();
while ($row = db_fetch_array($res))
	$msg_count[$row['forum_id']] = $row['cnt'];

echo '<H2>Discussion Forums</H2>
<P>Choose a forum and you can browse, search, and post messages.</P>
';

// Put the result set (list of forums for this project) into a column with
// folders

print "<TABLE width=\"100%\" border=0>\n<TR><TD valign=\"top\">\n"; 

reset($names);
while (list($forum_id,$name) = each($names)) {
	print '<A HREF="forum.php?forum_id='.$forum_id.'">';
	if ($MODE != 'T') {
		html_image('ic/cfolder15.png');
		print ' &nbsp; ';
	}
	$s = 0;
	if (isset($msg_count[$forum_id]))
		$s = $msg_count[$forum_id];
	if (!$name)
		$name = "(no name)";
	print $name . "</A> ($s msgs)";
	if (isset($USER) && $onlypublic && !$p_post[$forum_id])
		print ' (read only)';
	print "<BR>\n";
}
print "</TD></TR></TABLE>\n";
forum_footer();

?>
