<?php
# Some thread utilities.
# $Id: thutils.php,v 1.3 2001/11/10 15:36:29 sf Exp $

$sys_datefmt = "d M Y";

// Show all messages in a thread.
// $et (expand threads):
//	0 ... normal, just show messages
//	1 ... also show body
// $noheader - if set, is called from show_threads (expanded)
function show_thread($thread_id,$et=0,$noheader=0) {
	global $sys_datefmt, $MODE;
	global $st_msgs, $st_rownr, $st_do_forumheader, $db_prefix;

	// Get all messages in the thread.
	if( $et ) $b=",body"; else $b="";
	$sql = "SELECT user_name,message_id,thread_id,followup_to,language_code,ts,subject$b "
		. "FROM $db_prefix"."message,$db_prefix"."user "
		. "WHERE thread_id=$thread_id "
		. "AND user_id=posted_by "
		. "ORDER BY ts DESC, subject ASC, followup_to ASC "
		. "LIMIT 0,100";

	$res = db_query( $sql );
	if( !$res ) { print db_query_error(); return; }
	if( db_numrows($res) < 1 ) { print "Broken Thread<br>"; return; }

	// fetch all the messages into an array.  This could get rather large
	// in expanded mode...
	$st_msgs = array();
	while( $row = db_fetch_array($res) ) {
		$st_msgs[$row['followup_to']][] = $row;
	}

	// if we're doing that, the thread_header has to wait until
	// forum_header has been called.
	if( !$st_do_forumheader && !$noheader ) {
		thread_header();
		$st_rownr = 0;
	}

	// start with the mesage that has followup_to 0 (should be only one)
	// then, look for all that have a follow_up for this message etc.
	show_msgs(0,0,$noheader);
	if( !$noheader )
		print "</TABLE>\n";
}

// <COLPROJECT><COL><COL width="15%"><COL width="15%"></COLPROJECT>

function thread_header() {
	global $colors;
?>
<TABLE width="100%" cellpadding="2" cellspacing="0" bgcolor="#ffffff" border="0">
<TR bgcolor="<?php print $colors['menubarback'] ?>">
 <TD><FONT color="#000000"><B>Thread/Subject</B></FONT></TD>
 <TD><FONT color="#000000"><B>Author</B></FONT></TD>
 <TD><FONT color="#000000"><B>Date/Time</B></FONT></TD>
</TR>
<?php
}

// show all submessages of $msg_id
// NOTE: all the relevant messages must have already been loaded into $st_msgs
// XXX prevent loops
function show_msgs($msg_id,$st_level,$noheader=0) {
	global $st_msgs, $st_rownr, $MODE;
	global $st_subject, $st_msgid;
	global $st_curr_message_id;
	global $sys_datefmt;
	global $st_do_forumheader;

	if( !isset($st_msgs[$msg_id]) ) return;
	$message_link = get_link('forum:message');
	reset( $st_msgs[$msg_id] );
	while( list($k,$row) = each($st_msgs[$msg_id]) ) {
		if( $st_do_forumheader ) {
			forum_header( 'forum:thread', $row['subject'] );
			thread_header();
			$st_do_forumheader = 0;
		}
		print '<TR BGCOLOR="'.alt_row_color($st_rownr++).'"><TD>';

		$pre = '';	// before the image
		$mid = '<B>';	// before the text
		$post = '</B>';	// after the text

		if( $row['message_id'] != $st_curr_message_id ) {
			$pre = '<A href="'.$message_link.'?msg_id='.$row['message_id'].'">';
			$mid = '';
			$post = '</A>';
		}

		print $pre;

		if( $MODE != 'T' ) {
			// level 0 are actually threads, so show the thread
			// icon.  I could, equally well, check whether
			// followup_to is 0.
			if( $noheader && $st_level == 0 )
				html_image('ic/cfolder15.png');
			else
				html_image('msg.gif');
			print ' ';
		}
		
		// indent, depending on the level
		for($i=0;$i<$st_level;$i++)
			print ' &nbsp; &nbsp; ';
		print $mid . $row['subject'] . $post;

		// See if this message is new or not
		// if (get_forum_saved_date($forum_id) < db_result($result,$i,'date')) { $ret_val .= '<B>'; }

		print '</TD><TD>'.$row['user_name']
			.'</TD><TD>'.date($sys_datefmt,$row['ts'])
			.'</TD></TR>';

		// optionally show the body of the messages
		if( isset($row['body']) ) {
			print '<TD bgcolor="'.alt_row_color($st_rownr++)
				. '"><TD>&nbsp</TD><TD colspan=2>'
				. nl2br($row['body'])
				. '</TD></TR>';
		}
		print "\n";

		// find out what the subject and msgid of the *last* message
		// is -- for a followup in the thread.
		$st_subject = $row['subject'];
		$st_msgid = $row['message_id'];

		// any submessages?
		show_msgs($row['message_id'],$st_level+1);
	}
}

?>
