<?php

function html_image($src,$args='',$display=1) {
	global $BASEDIR;
	if( !is_array($args) ) $args=array();
	$return = '';

	// cant use image server for secure
#	if (session_issecure()) {
		$return .= ("<IMG src=\"$BASEDIR/images/$src\"");
#	} else {
#		$return .= ('<IMG src="http://images.sourceforge.net/'.$src.'"');
#	}
	reset($args);
	while(list($k,$v) = each($args)) {
		$return .= ' '.$k.'="'.$v.'"';
	}

	// ## insert a border tag if there isn't one
	if( !isset($args['border']) ) $return .= ' border=0';
	
	// ## if no height AND no width tag, insert em both
	if( !isset($args['height']) && !isset($args['width']) ) {
		$size = getimagesize($BASEDIR.'/images/'.$src);
		$return .= ' ' . $size[3];
	}

	// ## insert alt tag if there isn't one
	if (!isset($args['alt'])) $return .= " alt=\"$src\"";

	$return .= ('>');
	if ($display) {
		print $return;
	} else {
		return $return;
	}
}

function html_blankimage($height,$width) {
	return html_image('blank.gif',array('height'=>$height,'width'=>$width));
}

/* ------------------ error handling ------------------- */

$ERROR_STRING='';

function error_get_string() {
	global $ERROR_STRING, $DB_ERROR;
	return $ERROR_STRING . $DB_ERROR;
}

function set_error($string) {
	global $ERROR_STRING;
	if (strlen($ERROR_STRING) > 0) {
		//if there's already a string, add to it, delimiting it
		$ERROR_STRING .= ' || '.$string;
	} else {
		$ERROR_STRING=$string;
	}
}

/* --------------------------- box drawing ------------------------- */

function html_box1_top($title,$echoout=1,$bgcolor='#FFFFFF') {
	global $colors;

	$return = '<TABLE cellspacing="0" cellpadding="1" width="100%" border="0" bgcolor="'
		.$colors['menubarback']."\">\n<TR><TD>";

	$return .= '<TABLE cellspacing="1" cellpadding="2" width="100%" border="0" bgcolor="'.$bgcolor."\">\n".
		'<TR BGCOLOR="'.$colors['menubarback'].'" align="center">'."\n".
		'<TD colspan=2><SPAN class=titlebar>'.$title.'</SPAN></TD></TR>'."\n".
		'<TR align=left><TD colspan=2>'."\n";
	if ($echoout) {
		print $return;
	} else {
		return $return;
	}
}

function html_box1_middle($title,$bgcolor='#FFFFFF') {
	global $colors;

	return '</TD></TR>'."\n"
	.'<TR BGCOLOR="'.$colors['menubarback'].'" align="center">'."\n"
	.' <TD colspan=2><SPAN class=titlebar>'.$title.'</SPAN></TD>'."\n"
	.'</TR><TR align=left bgcolor="'.$bgcolor.'">'."\n"
	.' <TD colspan=2>'."\n";
}

function html_box1_bottom($echoout=1) {
	$return = '</TD></TR></TABLE><P>'."\n";
	$return .= '</TD></TR></TABLE><P>'."\n";
	if ($echoout) {
		print $return;
	} else {
		return $return;
	}
}

/* ------------------------ Other utilities ---------------------------- */

// return alternating row colors
function alt_row_color ($i) {
	global $colors;
	return ($i%2) ? $colors['ltback1'] : '#ffffff';
}

// TODO: use only the 216 standard colors for this.
$bgpri = array('','#dadada','#dad0d0','#dacaca','#dac0c0','#dababa',
	'#dab0b0','#daaaaa','#da9090','#da8a8a');

// Return the color value for the index that was passed in
function get_priority_color($index) {
	global $bgpri;
	return $bgpri[$index];
}

// Show a small table with the colors
function show_priority_colors_key() {
	echo "<P><B>Priority Colors:</B><BR>\n<TABLE BORDER=0><TR>";
	for ($i=1; $i<10; $i++) {
		echo '<TD BGCOLOR="'.get_priority_color($i).'">'.$i.'</TD>';
	}
	echo '</TR></TABLE>';
}

?><?php
// returns the code for a help link
function help($msgid,$print=1) {
	global $PAGENAME, $MODE;
	$help_link = get_link("help");
	$s = '<A href="'.$help_link.'?pg='.rawurlencode($PAGENAME)
		.'&id='.rawurlencode($msgid).'">';
	if( $MODE == 'T' ) {
		$s .= "Help";
	} else {
		$s .= html_image('help.gif',array('alt'=>'Help'),0);
	}
	$s .= '</A>';
		
	if( $print ) print $s;
	return $s;
}

function trim_text(&$text) {
	// remove trailing whitespace
	while(strlen($text)>0 && ord(substr($text,-1,1)) <= 32)
		$text = substr($text,0,-1);
	// remove leading whitespace
	while(strlen($text)>0 && ord(substr($text,0,1)) <= 32)
		$text = substr($text,1);
}

?>
