<?php // MODULEID=nav
// Site Navigation: the top strip of links and all the authentication issues.

include "$INCDIR/auth.php";		// auth_xxx plugins
include "$INCDIR/sitemap.php";


// maybe do on-demand loading here some day.
function get_page($pagename) {
	global $SITEMAP;
	return isset($SITEMAP[$pagename]) ? $SITEMAP[$pagename] : '';
}


// show the path up to $pagename
function nav_path($pagename,$level=0) {
	global $project_id, $projectcat_id, $thread_id, $forum_id;
	global $msg_id, $org_id;
	global $SESSION_VAR, $url_path;

	$ent = get_page($pagename);
	if( !isset($ent) )
		return '';

	// Find parent.  This can be explicitely set for this page using the
	// session variable $NAVPATH[pagename], or else check the $SITEMAP.
	$parent = '';
	if( isset($SESSION_VAR['NAVPATH'][$pagename]) )
		$parent = $SESSION_VAR['NAVPATH'][$pagename];
	elseif( isset($ent['parent']) )
		$parent = $ent['parent'];

	$res = $parent ? nav_path($parent,$level+1).' &gt; ' : '';

	// this is a hack...  Actually I should walk the list of entries of
	// $ent, and try to call "path_$name", until the first one returns
	// something.

	$linkadd = '';
	if( isset($ent['message']) )
		$linkadd = "?msg_id=$msg_id";
	elseif( isset($ent['thread']) )
		$linkadd = "?thread_id=$thread_id";
	elseif( isset($ent['forum']) )
		$linkadd = "?forum_id=$forum_id";
	elseif( isset($ent['project']) )
		$linkadd = "?project_id=$project_id";
	elseif( isset($ent['projectcat']) )
		$linkadd = "?projectcat_id=$projectcat_id";
	elseif( isset($ent['org_id']) )
		$linkadd = "?org_id=$org_id";

	// level 0 is the current page, it doesn't get a link, but is bold.
	if( $level == 0 )
		$res .= '<B>'.gm("nav:$pagename")."</B>\n";
	else
		$res .= '<A href="'.$url_path.$ent['link'].$linkadd.'">'.gm("nav:$pagename")."</A>\n";

	return $res;
}


/*
 *  Check permissions of the user to view this page.  Also, if required, query
 *  PROJECT, FORUM, MESSAGE.
 *
 *  USER must already be set if the user is logged in.
 *
 *  NOTE: this does not (yet) encompass ALL permissions - some are checked on
 *	  the inidividual page itself.
 *
 *  Parameter: $ent is $SITEMAP[pagename].  $mode: 0=auth  1=nav_path  2=nav_next
 *  RC: 0=permission granted
 *      1=denied $WHYNOT is the message ID of an explanation.
 *	2=as 1, but the cause is related to the user not being logged in.
 *	3=some prerequisite failed: missing or invalid parameter, db error
 */
?><?php
function nav_check($ent,$mode) {
	global $WHYNOT, $USER;

	reset($ent);
	while( list($k,$v) = each($ent) ) { switch($k) {

	// don't care about this
	case 'parent':
	case 'link':
	continue;

	// must be logged out (e.g. for login)
	case 'logout':
	if( !isset($USER) ) continue;
	$WHYNOT='nav:notloggedout';
	return 1;

	// Does the user have to be logged in?
	case 'login':
	if( isset($USER) ) continue;
	$WHYNOT='nav:loggedin';
	return $GLOBALS['disable_auth'] ? 3 : 2;

	// anything else - try to call the plugin
	default:
	$func = "auth_$k";
	if( !function_exists($func) ) {
		error_log("nav_check: Can't call $func!");
		$WHYNOT='nav:internalerror';
		return 3;
	}

	$rc = $func($v,$mode);
	// error_log( "AUTH $func -> $rc." );
	if( $rc ) return $rc;

	} 
	}

	return 0;
}


// Show all subnodes of $pagename.  Each link is checked for whether the user
// would be allowed to view it.  If not, don't even show the link.
function nav_next($pagename,$mode=0,$headline='') {
	global $SITEMAP, $WHYNOT, $disable_auth, $url_path;
	global $linkadd;		// set by nav_check()
	global $reg_state, $ORG;		// for specials

	reset($SITEMAP);
	$res = '';
	$found = 0;
	if( $mode == 1 ) {
		if( !$headline ) $headline = gm("nav:$pagename");
		$res .= menuhtml_top("<B>".$headline."</B>",0); 
	}
	while( list($k,$ent) = each($SITEMAP) ) {
		// check only the pages whose parent is $pagename.
		if( !isset($ent['parent']) || $ent['parent'] != $pagename )
			continue;
		// no link given -> can't enter.  This is the case for pages
		// that need an extra parameter and don't have subpages.
		if( !isset($ent['link']) )
			continue;

		// would this user be allowed to view the page?
		//error_log("[$k]");
		$linkadd = '';
		if( $rc = nav_check($ent,2) ) {
			if( !($disable_auth && $rc != 3) )
			 // print "Can't see $k: " . gm($WHYNOT) . "<br>\n";
				continue;
		}

		// note: the displayed Name of the page is nav:$pagename
		$s = "<A href=\"$url_path$ent[link]$linkadd\">".gm("nav:$k").'</A>';
		if( $mode == 1 ) {
			if( !$found ) $res .= "<UL>\n";
			$res .= "<LI> $s\n";
			$found = 1;
		} else {
			if( $res ) $res .= ' | '; else $res = ' &gt;&gt; ';
			$res .= $s;
		}
	}
	if( $mode == 1 ) {
		if( !$found ) {
			print "No subpages\n";
		} else {
			$res .= "</UL>\n";
		}
		$res .= menuhtml_bottom(0);
	}
	return $res;
}


function get_link($pagename) {
	global $url_path;
	$ent = get_page($pagename);
	if( !isset($ent) )
		return get_link('root:nopage') . "?pg=$pagename";
	if( !isset($ent['link']) )
		return get_link('root:nopage') . "?pg=$pagename";
	return $url_path . $ent['link'];
}

function get_parent($pagename) {
	$ent = get_page($pagename);
	if( !isset($ent) ) return '';
	return $ent['parent'];
}

?>
