<?php // MODULEID=session
// Code required to authenticate a user, and to create a session.

// authenticate a user with $user and $pass.  RC:0=ok 1=err 2=dberr
function session_login_valid($name,$pass,$allowpending=0) {
	global $session_hash, $USER, $db_prefix;

	//error_log("session_login_valid($name,$pass,$allowpending)",0);
	
	if( !$name || !$pass ) {
		set_error(gm('session:missing'));
		return 1;
	}

	# The user/password combination must exist.
	$res = db_query("SELECT * FROM ".$db_prefix."user "
		. "WHERE user_name='$name' AND password='".md5($pass)."'");
	if(!$res)
		return 2;
	if(db_numrows($res) < 1) {
		set_error(gm('session:invalid'));	// invalid user/password
		return 1;
	}

	# The user must be active.
	$user = db_fetch_array($res);
	$st = $user['status'];

	if($st == 'A' || $allowpending && $st == 'P') {
		$USER = $user;
		session_set_new();
		return 0;
	}

	// user is not active...
	if($st == 'P') {
		session_redirect(get_link('pending')."?form_user=$user[user_id]");
		exit;
	}

	set_error(gm("session:invalid_$st"));
	return 1;
}

// Create a new session.  $USER is set.  Called from session_login_valid.
// RC: 0=ok 1=err 2=dberr
function session_set_new() {
	global $SESSION, $USER, $db_prefix;

	# Remove old session if it exists.
	$user_id=$USER['user_id'];
	$res = db_query("DELETE FROM $db_prefix"."session "
		. "WHERE user_id=$user_id");
	if(!$res)
		return 2;

	# generate unique session ID.
	for(;;) {
		$session_hash = md5(uniqid(rand()));
		$res = db_query("SELECT session_hash "
			. "FROM $db_prefix"."session "
			. "WHERE session_hash='$session_hash'");
		if(!$res)
			return 2;
		if(!db_numrows($res))
			break;
	}

	# NOTE: no locking is performed here, so POSSIBLY two users could
	# login at the same time and by chance get the same session_hash.  I
	# could try to calculate the probability, but it's probably 0.

	// make a new entry into the session table.
	$now = time();
	$res = db_query("INSERT INTO ".$db_prefix."session"
		. "(session_hash,ip_addr,user_id,when_start,when_last)"
		. " VALUES ('$session_hash','" . $GLOBALS['REMOTE_ADDR']
		. "',$user_id,$now,$now)");
	if(!$res) {
		print db_query_error();
		return 2;
	}

	// set the cookie.
	session_cookie('session_hash',$session_hash);

	// this should produce the same $SESSION as session_set().
	$SESSION = array(
		'session_hash' => $session_hash,
		'when_start' => $now,
		'when_last' => $now,
		'ip_addr' => $GLOBALS['REMOTE_ADDR'],
		'user_id' => $user_id,
		'vars' => ''
	);
}

?>
