<?php
// This file is included by every file in this site.
// $Id: pre.php,v 1.7 2001/11/11 00:04:56 sf Exp $
//
// It provides following functions:
//
//	authenticate	validate access to the current page, thereby loading
//			lots of global variables like $USER $SESSION $PROJECT etc.
//	site_header	produces the header of the page
//	site_footer	produce a standard footer

error_reporting(63);

// Including: without PHP's "include" variable set (in httpd.conf), all
// "include" and "require" statements are relative to the main PHP script
// started - in require'd pages it's still relative to this first script,
// UNLESS I do a chdir() here to the base directory.

// Try to determine the base directory relative to the current directory, which
// is the one in $SCRIPT_NAME.  Also, find the url_path, which is the path
// relative to $DOCUMENT_ROOT to the base directory of webprojectdb in this
// installation.
$basedirs = array(".", "..", "../..");
$url_path = $SCRIPT_NAME;
foreach ($basedirs as $BASEDIR) {
	# chop of the trailing path element
	$url_path = substr($url_path, 0, strrpos($url_path, "/"));
	if (file_exists($BASEDIR . "/include/pre.php")) {
		break;
	}
}
unset($basedirs);
// chdir($BASEDIR); $BASEDIR=".";

$INCDIR="$BASEDIR/include";
include "$BASEDIR/../config.php";
include "$INCDIR/database.php";		// database access
include "$INCDIR/lang.php";		// gm(), text_xxx() etc.
include "$INCDIR/user.php";
include "$INCDIR/misc.php";
include "$INCDIR/session.php";		// session_xxx()
include "$INCDIR/menu.php";
include "$INCDIR/exit.php";
include "$INCDIR/nav.php";		// site navigation

// All available themes.
$themes = array(
	'N' => 'default.php',
	'T' => 'text.php',
	'S' => 'simple.php'
);

$disable_auth = 0;		// just for testing purposes.


// --------- main: all pages start here -------------

// determine the language the user has selected (can be overridden later)
if (isset($HTTP_ACCEPT_LANGUAGE)) {
	$LANG = split(', *',$HTTP_ACCEPT_LANGUAGE);
	while(list($k,$v)=each($LANG))
		$LANG[$k] = substr($v,0,2);
//		if($pos=strpos($v,';'))
//			$LANG[$k] = substr($v,0,$pos);
}

unset($USER);		// USER is usually set to "root"
unset($SESSION);
if (isset($USER))
	error_log("USER doesn't go away!");

// connect to the database.
if (db_connect()) {
	exit_error('ERROR',gm('pre:dbconn',array('msg'=>db_error())));
}

// require 'logger.php';

// try to authenticate the user (when the session_hash cookie is set)

$rc = session_set();
if ($rc)
	exit_error('ERROR',$AUTHFAIL);

include "$INCDIR/themes/$themes[$MODE]";


// Check whether the user can see this page.  On failure, output an error
// message and exit.
// This function is idempotent (i.e., can be called again, checks are only
// performed on the first call).
//
// Use of this: some pages need to authenticate first, then determine the
// page's name, and then call site_header.  site_header calls this function
// (again).
function authenticate($pagename) {
	global $SITEMAP, $WHYNOT, $AUTHFAIL, $disable_auth, $NP, $SESSION_VAR;
	static $is_authenticated = 0;

	if ($is_authenticated)
		return;

	// note: do *not* call exit_error() or similar, as this calls
	// site_header, and this calls here again.  This *could* lead to
	// problems.
	if (is_array($pagename)) {
		print "<HTML><BODY>Internal Error: The page $pagename[title] has no navigation.</BODY></HTML>\n";
		exit;
	}

	if (!isset($SITEMAP[$pagename])) {
		print "<HTML><BODY>Internal error: page $pagename doesn't exist.</BODY></HTML>\n";
		exit;
	}

	// modify navpath.
	if (isset($NP)) {
		error_log("setting navpath for $pagename to $NP");
		$SESSION_VAR['NAVPATH'][$pagename] = $NP;
		// session_var_set("NAVPATH[$pagename]",$NP);
	}

	// 3 (meaning some prerequisite failed) cannot be overriden.
	$WHYNOT='nav:unknownfailure';
	$rc = nav_check($SITEMAP[$pagename],0);
	if (($rc == 0) || ($disable_auth && $rc !=3)) {
		$is_authenticated = 1;
		return;
	}

	// AUTHFAIL may contain additional information from session_set
	print "<HTML><BODY>\n" . gm($WHYNOT);
	if ($rc == 2 && $AUTHFAIL) {
		print "<p>The underlying cause for this is: $AUTHFAIL</p>\n";
	}
	print "</BODY></HTML>\n";
	exit;
}


?>
