<?php
# Note: you have to include at least lang.php too
# $Id: project.php,v 1.5 2001/11/11 22:41:07 sf Exp $

// Get the project's name.  By default, the name of the current project.
function project_getname($project_id='',$language_code='') {
	global $PROJECT_NAMES, $LANG;

	if( !$project_id ) $project_id=$GLOBALS['PROJECT']['project_id'];
	if( !$project_id ) return 'project_getname(): no project Id given.';
	if( isset($PROJECT_NAMES[$project_id]) ) {
		$s = $PROJECT_NAMES[$project_id];
		error_log("Projectname-hit for $s",0);
		return $s;
	}
	$l = $language_code ? $language_code : $LANG;
	$s = text_get('project_name',$project_id,$l);
	$s = count($s) ? $s[''] : '';
	if( !$language_code ) $PROJECT_NAMES[$project_id] = $s;
	return $s;
}

$tabs = array(
	'summary' => array('link'=>'project:main','icon'=>'ic/anvil24.png','always'=>1),
	'home' => array('link'=>'-hp-','icon'=>'ic/home.png','always'=>1),
	'forum' => array('icon'=>'ic/notes.png', 'link'=>'project:forums'),
	'bug' => array(),
	'support' => array(),
	'patch' => array(),
	'mail' => array(),
	'pm' => array('icon'=>'ic/index.png'),
	'survey' => array(),
	'news' => array(),
	'cvs' => array('icon'=>'ic/convert.png'),
	'download' => array('icon'=>'ic/save.png','link'=>'/project/filelist.php')
);

/*
 *  Display the row of links at the top.
 *  $PROJECT must be set (result from SELECT * from project WHERE ...).
 *  $curr_tab is the currently highlighted tab.
 *
 *	if $PROJECT[language_code] is set, show project name in this language,
 *	else follow the usual method of using $USER[languages];
 *
 *	$PROJECT[project_name] will be set.
 */
function project_tabs($curr_tab) {
	global $PROJECT, $tabs, $MODE, $LANG;

	$PROJECT['project_name'] = project_getname($PROJECT['project_id'],isset($PROJECT['language_code'])?$PROJECT['language_code']:'');

	if( $MODE == 'T' ) {
		print "<H1>$PROJECT[project_name]</H1>\n";
		return;
	}


	// software map trail
	// print project_fullname($project)."\n<BR>";

	print '<TABLE width="100%" border="0" cellspacing="0" cellpadding="0">'
		. "\n <TR>\n";

	// header text
	if( !$curr_tab ) $curr_tab = 'home';
	$s = gm("project:$curr_tab");

	print '  <TD align="left"><FONT size="+2"><B>'
		. $PROJECT['project_name']
		. " - $s</B></FONT></TD>\n  <TD align=\"right\">\n";

	// All the individual links
	//   default for icon is /ic/<key>.png
	//  - default for link is project:<key>

	reset($tabs);
	while (list($k, $v) = each($tabs)) {
		if (!isset($v['always'])) {
			if ($PROJECT['status'] != 'A')
				break;
			if (!(isset($PROJECT["use_$k"]) && $PROJECT["use_$k"]))
				continue;
		}
		$s = isset($v['link']) ? $v['link'] : "project:$k";
		if (substr($s, 0, 1) != '/')
			$s = get_link($s);

		// No homepage defined (NULL value) -> skip
		if ($s == '-hp-' && !isset($PROJECT['homepage']))
			continue;

		// generate the link
		print '   <A ';
		if ($k == $curr_tab)
			print 'class=tabs ';
		if ($s == '-hp-')
			print 'href="http://'.$PROJECT['homepage'].'">';
		else
			print "href=\"$s?project_id=$PROJECT[project_id]\">";

		// icon
		$s = isset($v['icon']) ? $v['icon'] : "/ic/$k.png";
		html_image($s,array('alt'=>gm("project:$k",array(),$LANG,1),
			'border'=>($k==$curr_tab)));
		print "</A>\n";
	}

	// common table code
	print "  </TD>\n </TR>";

/*
	// bottom ruler
	print " <TR><TD colspan=\"2\">";
	html_blankimage(4,1);
	print "</TD></TR>\n";
	print '<TR bgcolor="#000000"><TD colspan="2">';
	html_blankimage(2,1);
	print "</TD></TR>\n";
*/
	print "</TABLE><BR>\n";
}

// load the given project into $PROJECT.  An error will terminate the script.
function project_get($project_id) {
	global $PROJECT, $db_prefix;

	if( !$project_id )
		exit_error(gm('project:noproject_title'), gm('project:noproject_text') );

	$res = db_query("SELECT * FROM ".$db_prefix."project "
		. "WHERE project_id=$project_id");
	if( !$res ) exit_dberror();
	if (db_numrows($res) < 1) 
		exit_no_project();
	$PROJECT = db_fetch_array($res);
}

?>
