<?php
// Query various user's permissions.
// $Id: user.php,v 1.3 2001/11/11 00:11:04 sf Exp $

// Is the user currently logged in?  True if $USER is set.
function user_isloggedin() {
	global $USER;
	return isset($USER) ? 1 : 0;
}

// get a user name & cache.
function user_getname($user_id=0) {
	global $USER, $USER_NAMES, $db_prefix;

	// default - return the name of the current user.
	if( !$user_id || (isset($USER) && $user_id==$USER['user_id']) )
		return isset($USER) ? $USER['user_name'] : 'NA';

	// was seen before?
	if( isset($USER_NAMES["user_$user_id"]) )
		return $USER_NAMES["user_$user_id"];

	// no, fetch.
	$res = db_query( "SELECT user_id,user_name "
		. "FROM ".$db_prefix."user "
		. "WHERE user_id=$user_id");
	if( $res && db_numrows($res)>0 )
		return $USER_NAMES["user_$user_id"] = db_result($res,0,'user_name');

	// invalid
	return $USER_NAMES["user_$user_id"] = "<b>Invalid user ID $user_id</b>";
}

function user_getid() {
	global $USER;
	return isset($USER) ? $USER['user_id'] : 0;
}

// does the (given) user have the permission $p in the current project?
// type: '' or 'm'=be member  f=forum tech  F=forum admin  A=admin
//	else check for field "p_$type"
// RC: 0=no or ERROR, 1=yes
function user_project_perm($p,$user_id=0) {
	global $USER_PROJECT, $USER, $project_id, $db_prefix;

	if( !$user_id ) {
		if( !isset($USER) || !isset($USER['user_id']) || !$USER['user_id'] )
			return 0;
		$user_id = $USER['user_id'];
	}
	error_log("user_project_perm($p,$user_id)");


	if( !isset($USER_PROJECT[$user_id]) ) {
		$res = db_query( "SELECT * FROM ".$db_prefix."user_project "
			. "WHERE project_id=$project_id "
			. "AND user_id=$user_id" );
		if( !$res ) return 0;
		if( db_numrows($res) < 1 ) {
			error_log("NO USER_PROJECT for user=$user_id, project=$project_id");
			$USER_PROJECT[$user_id] = array();
			return 0;
		}
		$USER_PROJECT[$user_id]=db_fetch_array($res);
	}
	$ug = $USER_PROJECT[$user_id];

	if( !count($ug) )
		return 0;

	switch( $p ) {
		case 'A': if($ug['p_admin']) return 1; break;
		case 'f': if($ug['p_forum'] == 1 || $ug['p_forum'] == 2) return 1; break;
		case 'F': if($ug['p_forum'] == 2 || $ug['p_forum'] == 3) return 1; break;
		case 'm':
		case '': return 1;
	}

	error_log("user_project_perm: $p");
	return isset($ug["p_$p"]) && $ug["p_$p"];
}


// check whether the user has a given permission.
function user_perm($p) {
	global $USER;
	return isset($USER) && isset($USER["p_$p"]) && $USER["p_$p"];
}

?><?php
// does the (given) user have the permission $p in the current org?
// RC: 0=no or ERROR, 1=yes
function user_org_perm($p,$user_id=0) {
	global $USER_ORG, $USER, $org_id, $db_prefix;

	if( !$user_id ) {
		$user_id = isset($USER) ? $USER['user_id'] : 0;
		if( !$user_id ) return 0;
	}

	if( !isset($USER_ORG[$user_id]) ) {
		error_log("user_org $user_id check...");
		$res = db_query( "SELECT * FROM ".$db_prefix."user_org "
			. "WHERE org_id=$org_id "
			. "AND user_id=$user_id" );
		if( !$res ) return 0;
		if( db_numrows($res) < 1 ) {
			$USER_ORG[$user_id] = 'NO';
			return 0;
		}
		$USER_ORG[$user_id]=db_fetch_array($res);
	}
	$uo = $USER_ORG[$user_id];
	if( $uo == 'NO' ) return 0;

	error_log("user_org $user_id valid");

	if( $p=='' ) return 1;		// just check validity of $user_id.
	return isset($uo["p_$p"]) && $uo["p_$p"];
}



?>
