<?php
# Add/Edit/Delete a contact for this org.
# $Id: editcontact.php,v 1.3 2001/11/10 15:01:59 sf Exp $

include '../include/pre.php';

authenticate('org:editcontact');
if(!isset($orgcontact_id))
	$orgcontact_id = 0;

# Add a new contact.  Returns an error message, or redirects back to the
# overview.
function do_add() {
	global $form_value, $form_oct_id, $org_id, $db_prefix;

	if(!$form_value) 
		return 'editcontact:empty';

	// check the contact type ID.  What a pity that MySQL doesn't have
	// referential integrity checks, it's all do-it-yourself.
	$res = db_query("SELECT orgcontacttype_id "
		. "FROM ".$db_prefix."orgcontacttype "
		. "WHERE orgcontacttype_id=$form_oct_id");
	if(!$res)
		return db_query_error();
	if(db_numrows($res) < 1)
		return 'editcontact:invalidoct';

	// insert it.
	$res = db_query("INSERT INTO ".$db_prefix."orgcontact"
		. "(org_id,contacttype_id,value) "
		. "VALUES($org_id,$form_oct_id,'$form_value')" );
	if(!$res)
		return db_query_error();

	// go back to org overview.
	session_redirect(get_link('org:view')."?org_id=$org_id");
}

function do_update() {
	global $form_value, $form_oct_id, $org_id, $orgcontact_id, $db_prefix;
	if( !$orgcontact_id || !$form_oct_id ) return 'fubar';
	if( !$form_value )
		return 'editcontact:empty';
	$res = db_query("UPDATE ".$db_prefix."orgcontact "
		. "SET contacttype_id=$form_oct_id,"
		. "value='$form_value' "
		. "WHERE orgcontact_id=$orgcontact_id");
	if(!$res)
		return db_query_error();
	session_redirect(get_link('org:view')."?org_id=$org_id");
}

$result = '';
if( isset($form_value) ) {
	trim_text($form_value);
	$form_value=nl2br($form_value);
}

if( isset($Add) ) {
	$result = do_add();
}

if( isset($Update) && $orgcontact_id ) {
	$result = do_update();
}

# Delete is simple, no separate subroutine.
if( isset($Delete) && $orgcontact_id ) {
	$res = db_query("DELETE FROM ".$db_prefix."orgcontact "
		. "WHERE orgcontact_id=$orgcontact_id");
	if(!$res)
		$result = db_query_error();
	else
		session_redirect(get_link('org:view')."?org_id=$org_id");
}

site_header('org:editcontact');

if( $result ) {
	print "<P>$result</P>";
}

// Normal: show a form to enter/edit contact

if( $orgcontact_id ) {
	$res = db_query( "SELECT value,contacttype_id "
		. "FROM ".$db_prefix."orgcontact "
		. "WHERE orgcontact_id=$orgcontact_id" );
	if(!$res)
		print db_query_error();
	if(db_numrows($res) < 1)
		print "Orgcontact $orgcontact_id not found.";
	$row = db_fetch_array($res);
	$form_value = $row['value'];
	$contacttype_id = $row['contacttype_id'];
	$mode = "Update";
} else {
	$form_value = '';
	$contacttype_id = 0;
	$mode = "Add";
}

$names = text_get('orgcontacttype_name','',$LANG);
if(count($names) == 0) {
	print "Sorry, but the site admin has not yet created contact types.";
	site_footer();
	exit(0);
}


print "<FORM action=\"$PHP_SELF\" method=\"post\">\n"
. "<INPUT type=\"hidden\" name=\"org_id\" value=\"$org_id\">\n"
. "<SELECT name=\"form_oct_id\">\n";

asort($names);
while(list($id,$name)=each($names)) {
	print "<OPTION value=\"$id\"";
	if( $id == $contacttype_id )
		print " SELECTED";
	print ">$name</OPTION>\n";
}
print "</SELECT><BR>\n";

$form_value=str_replace("<br>\n","\n",$form_value);
print "<TEXTAREA type=\"text\" name=\"form_value\" rows=5 cols=70>\n$form_value\n</TEXTAREA><BR>\n"
."<INPUT type=\"submit\" name=\"$mode\" value=\"$mode\">\n";
if( $orgcontact_id ) {
	print "<INPUT type=\"hidden\" name=\"orgcontact_id\" value=\"$orgcontact_id\">\n";
	print "<INPUT type=\"submit\" name=\"Delete\" value=\"Delete\">\n";
}
print "</FORM>\n";

site_footer();

?>
