<?php
# Here you can edit one member, i.e. change state and permissions, and
# possibly remove him from the project.
# $Id: editmember.php,v 1.2 2001/11/10 15:04:32 sf Exp $

include '../include/pre.php';

# checks user_id, uid, permissions to change etc.
authenticate('editmember');

// find out whether the current user can change/delete the user "uid".
function get_perm() {
	global $USER_ORG, $USER, $uid;		// input
	global $canchange, $candelete;		// output

	$canchange = 0;
	$candelete = 0;

	// can't do anything to admins, except when it's you and you're admin too
	if( !($USER_ORG[$uid]['p_admin'] && $uid != $USER['user_id']) ) {
		$canchange = user_org_perm('chmod');
		$candelete = user_org_perm('deluser');
	}

	// can always remove yourself.
	if( $uid == $USER['user_id'])
		$candelete = 1;
}

get_perm();

if( isset($Delete) && $candelete ) {
	db_query( "DELETE FROM ".$db_prefix."user_org "
		. "WHERE org_id=$org_id "
		. "AND user_id=$uid" );
	session_redirect(get_link('org:view')."?org_id=$org_id");
}

site_header('editmember');

if( isset($Update) && $canchange ) {

	$sql = '';
	$sets = array();

	while( list($field,$value) = each($USER_ORG[$uid]) ) {
		if( substr($field,0,2) != 'p_' )
			continue;
		$p = substr($field,2);

		// a user can give only permissions he has himself to others
		// unless he's admin
		if( !user_org_perm('admin') && !user_org_perm($p) )
			continue;

		$newval = isset($form_perm[$field]) ? '1' : '0';
		if( $newval != $value ) {
			$sets[] = "$field=$newval";
			$USER_ORG[$uid][$field] = $newval;
		}
	}

	if( count($sets) ) {
		$sql = "UPDATE $db_prefix"."user_org "
			. "SET ".join(',',$sets). " "
			. "WHERE org_id=$org_id "
			. "AND user_id=$uid" ;
		error_log($sql);
		$res = db_query( $sql );
		if( !$res ) print db_query_error();
		get_perm();
	} else {
		print "nothing changed.<br>\n";
	}
}


// a user can edit himself.
// p_deluser -> can delete a user
// p_chmod -> can change permissions of other users


print "User name: " . user_getname($uid) . "<br>\n";
print "User permissions:<br>\n";

// maybe insert the user's page here as soon as that's done.

$useform = ( $canchange || $candelete );

if( $useform ) {
	print "<FORM action=\"$PHP_SELF\" method=\"post\">\n";
	print '<INPUT type="hidden" name="org_id" value="'.$org_id."\">\n";
	print '<INPUT type="hidden" name="uid" value="'.$uid."\">\n";
}

// permissions: can only be changed if the user has p_chmod
//	p_admin	... can only be changed by admins.
//	p_xxx


print "<TABLE>\n";
reset($USER_ORG[$uid]);
while( list($field,$value) = each($USER_ORG[$uid]) ) {
	if( substr($field,0,2) != 'p_' )
		continue;
	print "<TR><TD>".substr($field,2)."</TD><TD>";
	$p = substr($field,2);
	if( $canchange && (user_org_perm('admin')||user_org_perm($p)) )
		print '<INPUT type="checkbox" name="form_perm['.$field.']" value="1"'
		.($value?' checked':'').'>';
	else
		print $value ? 'yes' : 'no';
	print "</TD></TR>\n";
}
print "</TABLE>\n";

if( $canchange ) {
	print '<INPUT type="submit" name="Update" value="Update">';
	if( $MODE == 'T' && $candelete ) print " | ";
}
if( $candelete ) {
	$s = "Remove Member";
	if( $uid == $USER['user_id'] ) $s = "Remove Yourself";
	print '<INPUT type="submit" name="Delete" value="'.$s.'">';
}
if( $useform )
	print "\n</FORM>\n";

site_footer();
?>
