<?php
# Show a list of organisations with links to manage them (permissions
# required).
# $Id: index.php,v 1.2 2001/11/10 15:07:01 sf Exp $

include '../include/pre.php';
site_header('org');

/*
Planned Pages.

NEXT:
	- editorg

- view an existing organisation: show contacts, members (vieworg.php)
  - members link to the user's page
  - for admins: edit org description/name
  - for admins: link to "addmember" page

- add a new org (addorg.php) OK
- list of organisations (index.php) OK
- for admins: members have additional link "edit"
	(editmember.php).  Can also remove the member here.


On a project's page, show list of orgs with links.
*/

# Determine which orgs to show (status).
$st = array();
if( isset($form['A']) ) $st[] = 'A';
if( isset($form['P']) && user_perm('orgmanage') ) $st[] = 'P';
if( isset($form['D']) && user_perm('orgmanage') ) $st[] = 'D';
if( !count($st) ) { $st[] = 'A'; $form['A']=1; }

# get a list of organisations.
$res = db_query( "SELECT * FROM $db_prefix"."org "
	. "WHERE status IN ('".join("','",$st)."')" );
if(!$res)
	print db_query_error();

$ids = array();
while( $row = db_fetch_array($res) ) {
	$ids[] = $row['org_id'];
	$orgs[$row['org_id']] = $row;
}

function cmpfunc($a,$b) {
	return strcmp(strtolower($a),strtolower($b));
#	return strcasecmp($a,$b);	# this does't work as expected (first
#	sorts on the string length...).
}

// Get names.  As this is *all* orgs but some not in active state, query all
// names.
if( count($ids) ) {
	$orgnames = text_get( 'org_name', '', $LANG );
	// XXX can this be done case-insensitive?
	uasort($orgnames,'cmpfunc');
} else
	$orgnames = array();

// show Header
$s = '';
reset($st);
while(list($k,$v)=each($st)) {
	if( $s ) $s .= ', ';
	$s .= gm("orgindex:status_$v");
}
print "<H1>" . gm('orgindex:list',array('type'=>$s)) . "</H1>\n";

// show list
print "<UL>\n";
$view_link = get_link("org:view");
while( list($oid,$name) = each($orgnames) ) {

	// skip the non-active ones.
	if( !isset($orgs[$oid]) )
		continue;

	print "<LI><A href=\"$view_link?org_id=$oid\">$name</A>";
	switch( $orgs[$oid]['status'] ) {
		case 'D': print " (deleted)"; break;
		case 'P': print " (pending)"; break;
		default: print " " . $orgs[$oid]['status'];
	}
	print "\n";
}
print "</UL>\n";

if( user_perm('orgmanage') ) {

?>
<HR noshade height=1>
<FORM action="index.php" method="get">
<?php if( isset($org_id) ) {
	print '<INPUT type="hidden" name="org_id" value="'.$org_id."\">\n";
	}
?>
<DIV align="center">
<TABLE>
<?php
function show_box($status) {
	global $form;
	print '<TR><TD>';
	print gm('orgindex:see',array('type'=>gm("orgindex:type_$status")));
	print '</TD><TD>';
	print '<INPUT type="checkbox" name="form['.$status.']" value="1"';
	if(isset($form[$status])) print ' checked';
	print "></TD></TR>\n";
}

show_box('A');
show_box('P');
show_box('D');

?>
</TABLE>
</DIV>
<DIV align="center">
<INPUT type="submit" name="foo" value="<?php print gm('orgindex:update'); ?>">
</DIV>
</FORM>
<?php

}

site_footer();
?>
