<?php
# Show the organisation's info, select users to modify, delete org, add new
# members
# $Id: vieworg.php,v 1.4 2001/11/11 22:41:43 sf Exp $

include '../include/pre.php';
include 'orgutils.php';

$sys_datefmt = "d M Y";

authenticate('org:view');

// get all info about this org.  names: key=field_id  value=text
$names = text_get( array('org_name','org_description'), $org_id, $LANG );

$org_name = $names[$FIELD_ID['org_name']];
$f_d = $FIELD_ID['org_description'];
$org_description = isset($names[$f_d]) ? $names[$f_d] : '';

switch( $ORG['status'] ) {
	case 'P':
	case 'D': $org_name .= ' (' . gm("vieworg:status_$ORG[status]") . ')';
}

site_header('org:view',$org_name);
print "<H1>$org_name</H1>\n";
print "<P><B>".gm('vieworg:description').":</B><BR>\n$org_description</P>\n";

// get the permissions of the current user
$isadmin = user_perm('orgmanage');
$p_admin = user_org_perm('admin');
$p_chmod = user_org_perm('chmod');

// show pending joins to projects, if the user is orgadmin or admin of this
// org.
if( $isadmin || $p_admin ) {
	show_pending();
}

print "<P><B>".gm('vieworg:members').":</B><BR>\n";

// query members of this org
$res = db_query( "SELECT user.user_id,user_org.ts,user.user_name "
	. "FROM $db_prefix"."user_org user_org,$db_prefix"."user user "
	. "WHERE org_id=$org_id "
	. "AND user.user_id=user_org.user_id" );
if( !$res ) print db_query_error();

print "<UL>\n";
while( $row = db_fetch_array($res) ) {
	print "<LI>$row[user_name]";
	$rc = auth_editmember($row['user_id']);
	if( $rc == 0 ) {
		print " <A href=\"editmember.php?org_id=$org_id&uid=$row[user_id]\">[Edit]</A>";
	}
	print "\n";
}
print "</UL>\n";

// query projects of this org
$res = db_query("SELECT project_id,ts,user_id,user_name "
	. "FROM $db_prefix"."project_org, $db_prefix"."user "
	. "WHERE org_id=$org_id "
	. "AND approved=1 "
	. "AND orgadmin_id=user_id");
if(!$res)
	print db_query_error();

if( db_numrows($res) > 0 ) {
	print "<P><B>".gm('vieworg:projects').":</B><BR>\n";
	$a = array();
	$b = array();
	while( $row = db_fetch_array($res) ) {
		$a[$row['project_id']] = $row;
		$b[] = $row['project_id'];
	}
	$names = text_get('project_name',$b,$LANG);
	asort($names);
	reset($names);
	$proj_link=get_link('project:main');
	print "<TABLE>\n";
	print "<TR><TH>Project</TH><TH>Since when</TH><TH>Approved by</TH></TR>\n";
	while(list($id,$name)=each($names)) {
		$row=$a[$id];
		print "<TR>\n";
		print " <TD><A href=\"$proj_link?project_id=$id\">$name</A></TD>\n";
		print " <TD>".date($sys_datefmt,$row['ts'])."</TD>\n";
		// XXX this should be a link to the user's public page.
		print " <TD>$row[user_name]</TD>\n";
		print "</TR>\n";
	}
	print "</TABLE>";
}


// get all contact type names
$ct_names = text_get('orgcontacttype_name','',$LANG);
asort($ct_names);

print "<H2>".gm('vieworg:contactinfo')."</H2>\n";

// show all contacts
if( user_org_perm('chfn') ) {
	$edit_link = get_link('org:editcontact');
	$p_chfn = 1;
} else
	$p_chfn = 0;

$res = db_query("SELECT * "
	. "FROM $db_prefix"."orgcontact "
	. "WHERE org_id=$org_id");
while( $row = db_fetch_array($res) ) {
	print "<p><b>".$ct_names[$row['contacttype_id']]."</b><br>\n";
	print "$row[value]";
	if( $p_chfn )
		print " <A href=\"$edit_link?org_id=$org_id&orgcontact_id=$row[orgcontact_id]\">[Edit]</A>";
	print "</p>\n";
}

site_footer();

?>
