<?php
# $Id: addorg.php,v 1.3 2001/11/10 12:07:23 sf Exp $

include '../include/pre.php';

site_header('project:addorg');

// Try to add an organisation to this project.
function do_addmember() {
	global $project_id, $form_org, $PROJECT, $feedback, $USER, $db_prefix;

	if( !user_project_perm('adduser') ) return 'addorg:nopermission';

	// check input
	if( !isset($form_org) ) return '';
	if( !$form_org ) return 'addorg:missingorg';

	// project must be valid
	if( $PROJECT['status'] != 'A' ) return 'addorg:notactive';

	// org must be valid
	$res = db_query( "SELECT org_id "
		. "FROM ".$db_prefix."org "
		. "WHERE org_id='$form_org'" );
	if(!$res)
		return db_query_error();
	$o = db_result($res,0,'org_id');
	if(!$o)
		return gm('addorg:notfound',array('org_id'=>$form_org));

	// org must not already be member
	$res = db_query( "SELECT * FROM ".$db_prefix."project_org "
		. "WHERE project_id=$project_id "
		. "AND org_id=$o" );

	if(!$res)
		return db_query_error();

	// Maybe approve now.  There's another place to do this, but why not
	// here too.
	if(db_numrows($res) != 0) {
		$row = db_fetch_array($res);
		if( $row['approved'] == 1 )
			return 'addorg:already';
		if( $row['projectadmin_id'] == 0 ) {
			$res = db_query( "UPDATE ".$db_prefix."project_org "
				. "SET approved=1,"
				. "projectadmin_id=$USER[user_id] "
				. "WHERE project_id=$project_id "
				. "AND org_id=$form_org" );
			return 'addorg:approved';
		}
		// so it's not approved by the org yet.
		return 'addorg:notapprovedbyorg';
	}

	// now do it.  If the user is also admin of this org, or overall org
	// manager, immedeately approve the project_org entry.
	$now = time();
	$orgadmin_id = 0;
	$approve = 0;
	if( user_perm('orgadmin') || user_org_perm('admin') ) {
		$orgadmin_id = $USER['user_id'];
		$approve = 1;
	}

	$res = db_query( "INSERT INTO ".$db_prefix."project_org"
		. "(project_id,org_id,ts,projectadmin_id,orgadmin_id) "
		. "VALUES($project_id,$o,$now,$USER[user_id],0)" );
	if( !$res ) return db_query_error();
	return gm('addorg:added',array('org'=>$form_org));
}

// -- main --
if( isset($AddMember) ) {
	$feedback = do_addmember();
	print "<P><B>\n" . gm($feedback) . "</B></P>\n";
}


//

?>
<FORM action="<?php print $PHP_SELF; ?>" method="post">
<INPUT type="hidden" name="project_id" value="<?php print $project_id; ?>">
<?php print gm('addorg:toadd'); ?><BR>
<SELECT name="form_org">
<?php
	// find the orgs that are *not yet* member of this project.
	// because MySQL doesn't have sub selects, do it in two steps.

	// What orgs are already in this project?
	$res = db_query( "SELECT org_id "
		. "FROM ".$db_prefix."project_org "
		. "WHERE project_id=$project_id" );
	if( !$res ) print db_query_error();
	$orgs = array();
	while( $row = db_fetch_array($res) )
		$orgs[] = $row['org_id'];

	// Find the orgs that are not member of this project.
	$sql = "SELECT org_id FROM ".$db_prefix."org";
	if(count($orgs))
		$sql .= " WHERE org_id NOT IN (".join(',',$orgs).")";
	$res = db_query( $sql );
	if(!$res)
		print db_query_error();
	$orgs = array();
	while($row = db_fetch_array($res)) {
		$orgs[] = $row['org_id'];
	}

	// Get the names, make default names
	$names = text_get('org_name',$orgs,$LANG);
	reset($orgs);
	while(list($k,$v)=each($orgs))
		if( !isset($names[$v]) )
			$names[$v] = "#$v";

	// Show them all
	asort($names);
	reset($names);
	while(list($id,$name)=each($names))
		print "<OPTION value=\"$id\">$name</OPTION>\n";

?>
</SELECT>
<INPUT type="submit" name="AddMember" value="Add">
</FORM>

<?php site_footer(); ?>
