<?php
# Several functions to handle project categories - get info, browse.  To be
# included by other scripts.
# $Id: category.php,v 1.2 2001/11/10 12:14:05 sf Exp $

// get info about current category
function category_get(&$cat_id) {
	global $CC, $db_prefix;

	$cat_id = isset($cat_id) ? intval($cat_id) : '0';
	if(!$cat_id)
		return;

	$res = db_query( "SELECT * FROM ".$db_prefix."projectcat "
		. "WHERE projectcat_id=$cat_id" );
	if(!$res)
		exit_error('Database error',db_query_error());
	if(db_numrows($res) < 1)
		exit_error('Invalid Category','This category does not exist.');

	$CC = db_fetch_array($res);
}

function show_count($row) {

	print " <I>($row[project_count]";
	if( $row['subproject_count'] )
		print "+$row[subproject_count]";
	print " projects)</I>";
}


// print the path to the current cat, and then all subcategories
function category_show($params) {
	global $CC, $MODE, $PHP_SELF, $LANG, $discrim_url, $db_prefix;

	if( !isset($CC) || !$CC['projectcat_id'] )
		return;

	$folders_ids = array();
	if( $CC['path'] ) {
		$s = $CC['path'];
		// remove the reference to root, if any.
		if( substr($s,0,2) == '0,' ) $s = substr($s,2);
		$folders_ids = explode(',',$s);
	}

	// get the names of all parents of the current node
	$folders_ids[] = $CC['projectcat_id'];
	$folders_len = count($folders_ids);
	$names = text_get('projectcat_name',$folders_ids,$LANG);

	// get the count info of all parents
	$res = db_query("SELECT projectcat_id,project_count,subproject_count "
		. "FROM ".$db_prefix."projectcat "
		. "WHERE projectcat_id IN (" . join(',',$folders_ids) . ")");
	if( !$res ) print db_quer_error();
	while( $row = db_fetch_array($res) ) {
		$counts[$row['projectcat_id']] = $row;
	}

/*  This doesn't pertain anymore.  text_get will *always* return some name.
	$diff = count($folders_ids) - count($names);
	if( $diff ) {
		print "There are $diff top level categories you don't see because of your restrictive language setting.<br>\n";
	}
*/
	// Show all parents of the current node.
	$spacer = '';
	if(!isset($params['link'])) $params['link'] = '';
	for( $i=0; $i<$folders_len; $i++ ) {
		$id = $folders_ids[$i];
		print $spacer;
		$spacer .= " &nbsp; &nbsp; ";
		if( $MODE != 'T' ) {
			html_image( "ic/ofolder15.png" );
			print " &nbsp; ";
		}

		// no anchor for current cat
		if( $id != $CC['projectcat_id'] )
			print '<A href="'.$PHP_SELF.'?cat_id='.$id.$discrim_url.$params['link'].'">';
		else
			print '<B>';

		print $names[$id];
		print ($id != $CC['projectcat_id']) ? '</A>' : '</B>';
		$row = $counts[$id];
		show_count($row);
		print "<BR>\n";
	}

	// print subcategories
	$res = db_query( "SELECT projectcat_id,root_parent_id,project_count,subproject_count "
		. "FROM ".$db_prefix."projectcat "
		. "WHERE parent_id=$CC[projectcat_id]" );
	if( !$res ) print db_query_error();
	if( !db_numrows($res) )
		return;

	$ent = array();
	$ids = array();
	while( $row = db_fetch_array($res) ) {
		$ent[$row['projectcat_id']] = $row;
		$ids[] = $row['projectcat_id'];
	}

	// find assoc. with project.
	if( isset($params['project_id']) ) {
		$res = db_query( "SELECT projectcat_id FROM ".$db_prefix."projectcat_project "
			. "WHERE project_id=$params[project_id] "
			. "AND projectcat_id IN (".join(',',$ids).")" );
		if( !$res ) print db_query_error();
		while( $row = db_fetch_array($res) ) {
			$ent[$row['projectcat_id']]['checked'] = ' checked';
		}
	}

	// Retrieve the names, sort them.
	$names = text_get('projectcat_name',$ids,$LANG);
	asort($names);

	// For each name, output one line.
	reset($names);
	$is_on = array();
	if(!isset($params['link'])) $params['link'] = '';

	while( list($id,$name) = each($names) ) {

		print $spacer;
		$row = $ent[$id];

		print "<A href=\"$PHP_SELF?cat_id=$id$discrim_url$params[link]\">";
		if( $MODE != 'T' ) {
			html_image( "ic/cfolder15.png" );
			print '&nbsp; ';
		}
		print $name . '</A> ';

		if( isset($params['project_id']) ) {
			print '<INPUT type="checkbox" name="has_gc[]" value="'
				.$id.':'.$row['root_parent_id'].'" ';
			if( isset($row['checked']) ) {
				print $row['checked'];
				$is_on[] = $id;
			}
			print '>';
		}
		show_count($row);
		print "<BR>\n";
	}
	if( isset($params['project_id']) ) {
		print '<INPUT type="hidden" name="is_on" value="'.join(',',$is_on)."\">\n";
	}
}

?><?php

// list the root categories.
function category_root($params) {
	global $CC, $PHP_SELF, $LANG, $MODE, $discrim_url, $db_prefix;

	// build a list of IDs
	$res = db_query( "SELECT projectcat_id,project_count,subproject_count "
		. "FROM ".$db_prefix."projectcat "
		. "WHERE parent_id=0" );
	print "<P>Browse by:\n";
	$ids = array();
	$counts = array();
	while( $row = db_fetch_array($res) ) {
		$ids[] = $row['projectcat_id'];
		$projects[$row['projectcat_id']] = $row;
	}

	// get all the names
	$names = text_get('projectcat_name',$ids,$LANG);
	asort($names);
	reset($names);

	while( list($id,$name) = each($names) ) {

		print "<BR>";
		$row = $projects[$id];
		if( isset($CC) && $id == $CC['root_parent_id'] ) {
			if( $MODE != 'T' ) {
				html_image("ic/ofolder15.png");
				print '&nbsp; ';
			}
			print "<B>$name</B>";
		} else {
			print "<A href=\"$PHP_SELF?cat_id=$id$discrim_url";
			if(isset($params['link'])) print $params['link'];
			print "\">";
			if( $MODE != 'T' ) {
				html_image("ic/cfolder15.png");
				print '&nbsp; ';
			}
			print "$name";
		}
		show_count($row);
		print "\n";
	}
	print "</P>\n";
}

?><?php
// XXX missing - discrimination

// left column: parent categories and current category
// only if current category is NOT root, as the root listing is always there.

function category_nav($params='') {
	global $MODE, $discrim_url;
	if( !is_array($params) ) $params=array();
	if( !isset($discrim_url) ) $discrim_url='';

	// text mode: list root categories first, then the current ones
	if( $MODE == 'T' ) {
		category_root($params);
		print "<hr>\n";
		category_show($params);
		return;
	}

	// otherwise: show current categories on the left, root cats right
	?><TABLE width="100%" border="0" cellspacing="0" cellpadding="0">
<TR valign="top"><TD width="70%">
<?php
	category_show($params);
	print "</TD><TD>\n";
	category_root($params);
	print "</TD></TR></TABLE>\n";
}

/*
 *  Show all the categories a given project is in, grouped by root node.
 *
 * 1. SELECT: get all categories of the given project
 * 2. retrieve the list of projectcat_ids, and build a list of root IDs
 * 5. SELECT: get all names of the projectcats (root & leaf)
 * 6. build a list of names for the roots, sort it
 * 7. for each root, print, and print all entries whose root_id is this root
 * 
 */
function category_showall($project_id) {
	global $LANG,$db_prefix;


	// get all the categories this project is in.
	$res = db_query( "SELECT * FROM ".$db_prefix."projectcat_project "
		. "WHERE project_id=$project_id" );
	if( !$res ) { print db_query_error(); return; }

	// note which projectcat_ids there are.
	$gc = array();		// all nodes (root+leaf)
	$gc_roots = array();	// all roots
	$nodes = array();	// for each root, all leaves
	while( $row = db_fetch_array($res) ) {
		$id = $row['projectcat_root_id'];
		$gc[$row['projectcat_id']] = $id;
		$gc[$id] = 0;
		$gc_roots[$id] = '';
		$nodes[$id][] = $row['projectcat_id'];
	}

	// build a list of IDs to fetch names for
	$ids = array();
	while(list($id,$v)=each($gc)) {
		$ids[] = $id;
	}
	asort($ids);	// probably doesn't make any difference to the DB

	// fetch all the relevant names
	$names = text_get('projectcat_name',$ids,$LANG);

	// replace all entries in $gc_roots with a name & sort
	reset($gc_roots);
	while(list($id,$v)=each($gc_roots)) {
		if( isset($names[$id]) )
			$gc_roots[$id] = $names[$id];
	}
	asort($gc_roots);

	// for each root cat, show it and all subnodes
	reset($gc_roots);
	while(list($id,$name)=each($gc_roots)) {
		// print the root cat name
		print $name . ': ';

		// print all leaves of this root cat
		$n = array();
		for($i=0;$i<count($nodes[$id]);$i++)
			$n[] = $names[$nodes[$id][$i]];
		asort($n);
		for($i=0;$i<count($n);$i++) {
			if( $i ) print ', ';
			print $n[$i];
		}
		print "<br>\n";
	}

	// done!
}

?>
