<?php
# Here you can edit one member, i.e. change state and permissions, and
# possibly remove him from the project.
#
# Note: nobody can change the permissions of a project admin, not even other
# admins.  OTOH, a site project manager can do everything.
#
# $Id: edituser.php,v 1.2 2001/11/10 11:44:20 sf Exp $

include '../include/pre.php';

// checks user_id, uid, permissions to change etc.
authenticate('project:edituser');

// find out whether the current user can change/delete the user "uid".
function get_perm() {
	global $USER_PROJECT, $USER, $uid;	// input
	global $canchange, $candelete;		// output
	global $is_manager, $is_admin;

	$canchange = 0;
	$candelete = 0;

	$is_admin = user_project_perm('admin');

	// overall project admins can do anything
	if($is_manager) {
		error_log("you are project manager");
		$canchange = $candelete = 1;
		return;
	}

	// you can always change yourself, even if you're admin
	if( $uid == $USER['user_id'] || !user_project_perm('admin',$uid) ) {
		$canchange = user_project_perm('chmod');
		$candelete = user_project_perm('deluser');
	}

	// can always remove yourself.
	if( $uid == $USER['user_id'])
		$candelete = 1;
}

# A site project manager can do everything here.
$is_manager = user_perm('projectmanage');
get_perm();

if( isset($Delete) && $candelete ) {
	db_query( "DELETE FROM ".$db_prefix."user_project "
		. "WHERE project_id=$project_id "
		. "AND user_id=$uid" );
	session_redirect(get_link('org:view') . "?project_id=$project_id");
}

site_header('project:edituser');

if( isset($Update) && $canchange ) {

	$sql = '';
	$sets = array();

	while( list($field,$value) = each($USER_PROJECT[$uid]) ) {
		if( substr($field,0,2) != 'p_' )
			continue;
		$p = substr($field,2);

		// a user can give only permissions he has himself to others
		// unless he's admin
		if( !user_project_perm('admin') && !user_project_perm($p) )
			continue;

		$newval = isset($form_perm[$field]) ? '1' : '0';
		if( $newval != $value ) {
			$sets[] = "$field=$newval";
			$USER_PROJECT[$uid][$field] = $newval;
		}
	}

	if( count($sets) ) {
		$sql = "UPDATE ".$db_prefix."user_project SET "
			. join(',',$sets)
			. " WHERE project_id=$project_id AND user_id=$uid" ;
		error_log($sql);
		$res = db_query( $sql );
		if( !$res ) print db_query_error();
		get_perm();
	} else {
		print "nothing changed.<BR>\n";
	}
}


// a user can edit himself.
// p_deluser -> can delete a user
// p_chmod -> can change permissions of other users


print "User name: " . user_getname($uid) . "<BR>\n";
print "User permissions:<BR>\n";

// maybe insert the user's page here as soon as that's done.

$useform = ( $canchange || $candelete );

if( $useform ) {
	print "<FORM action=\"$PHP_SELF\" method=\"post\">\n";
	print '<INPUT type="hidden" name="project_id" value="'.$project_id."\">\n";
	print '<INPUT type="hidden" name="uid" value="'.$uid."\">\n";
}

// permissions: can only be changed if the user has p_chmod
//	p_admin ... can only be changed by admins.
//	p_xxx


print "<TABLE>\n";
reset($USER_PROJECT[$uid]);
while( list($field,$value) = each($USER_PROJECT[$uid]) ) {
	if( substr($field,0,2) != 'p_' )
		continue;
	print "<TR><TD>".substr($field,2)."</TD><TD>";
	$p = substr($field,2);

	// you can only enable the permissions of somebody else that you have
	// yourself, except if you're overall project manager or this project's
	// admin.
	if( $canchange && ($is_manager||$is_admin||user_project_perm($p)) )
		print '<INPUT type="checkbox" name="form_perm['.$field.']" value="1"'
		.($value?' checked':'').'>';
	else
		print $value ? 'yes' : 'no';
	print "</TD></TR>\n";
}
print "</TABLE>\n";

if( $canchange ) {
	print '<INPUT type="submit" name="Update" value="Update">';
	if( $MODE == 'T' && $candelete ) print " | ";
}
if( $candelete ) {
	$s = "Remove Member";
	if( $uid == $USER['user_id'] ) $s = "Remove Yourself";
	print '<INPUT type="submit" name="Delete" value="'.$s.'">';
}
if( $useform )
	print "\n</FORM>\n";

site_footer();
?>
