<?php
# All entered data is shown again, the users confirms the validity of it.
# Then, the project is created.  All the data is stored in session variables.
# $Id: confirmation.php,v 1.5 2001/11/10 18:24:42 sf Exp $

include '../include/pre.php';

authenticate('register:confirmation');


# User clicked on "I disagree"
if(isset($reg_state) && isset($i_disagree)) {
	include 'abort.php';
	do_abort();
}


# Now really insert the stuff into the database.  But watch out: in the
# meantime, somebody else might have snatched away the project name etc.
if(isset($i_agree)) {

	$now = time();
	# Create the project with a status of "I" (meaning incomplete).  This
	# is just in case something goes wrong - then it's easy to see which
	# project is concerned.
	$res = db_query("INSERT INTO $db_prefix"."project"
		. "(unix_project_name,ts,status,rand_hash) "
		. "VALUES ('$reg_unixname',$now,'I','')");
	if(!$res) {
		exit_error(gm('regprojectname:error'),
			gm('regprojectname:insfail',
				array('admin'=>"admin@$sys_maildomain"))
			. db_error());
	}

	$reg_project = db_insertid();

	// recheck the unix name, somebody else might have created such a
	// project in the meantime!
	$res = db_query("SELECT project_id "
		. "FROM $db_prefix"."project "
		. "WHERE unix_project_name='$reg_unixname' "
		. "AND NOT project_id = $reg_project");

	if(db_numrows($res) > 0) {
		db_query("DELETE FROM $db_prefix"."project "
			. "WHERE project_id=$reg_project");
		exit_error("Sorry", "Somebody else created a project with your unix name in the meantime.  Go back and pick another.");
	}


	// store the texts
	text_set('project_purpose',$reg_project,$reg_lang,htmlspecialchars($reg_purpose));
	text_set('project_name',$reg_project,$reg_lang,$reg_name,1);

	// insert the language
	$res = db_query("INSERT INTO $db_prefix"."project_language"
		. "(project_id,language_code) "
		. "VALUES ($reg_project,'$reg_lang')");
	if(!$res)
		exit_error('Database Error',db_query_error());

/*
	// define a module
	$result=db_query("INSERT INTO filemodule (project_id,module_name) VALUES ('$reg_project','".project_getunixname($reg_project)."')");
	if (!$result) {
		exit_error('Error','INSERTING FILEMODULE FAILED. <B>PLEASE</B> report to admin@sourceforge.net'.db_error());
	}
*/

	// make the current user an admin
	$res=db_query("INSERT INTO $db_prefix"."user_project"
		. "(user_id,project_id,"
		. "p_admin,p_adduser,p_deluser,p_chfn,p_chmod,p_forum) "
		. "VALUES ($USER[user_id],$reg_project,1,1,1,1,1,2)");
	if(!$res)
		exit_error('Error',"SETTING YOU AS OWNER FAILED. "
			. "<B>PLEASE</B> report to admin@$sys_maildomain."
			. db_error());

	//Add a couple of forums for this project
	/* XXX not yet supported.
	forum_create_forum($reg_project,'Open Discussion',1);
	forum_create_forum($reg_project,'Help',1);
	forum_create_forum($reg_project,'Developers',0);
	*/

	//Set up some mailing lists
	//will be done at some point. needs to communicate with geocrawler

	// Finalize by marking projekt as "pending".
	$res = db_query("UPDATE $db_prefix"."project "
		. "SET status='P' "
		. "WHERE project_id=$reg_project");

	site_header('register:confirmation');
	print gm('regconfirm:complete');
	session_var_del(array('reg_state','reg_lang','reg_purpose','reg_name','reg_unixname'));
	site_footer();
	exit;
}




/* First: produce a form that shows all of the information entered so far, and
 * allows to modify some of it.
 * When the user selects one of the buttons, this script will be called again.
 */

site_header('register:confirmation');
$lang_name = lang_get_name($reg_lang);


echo '
<H2>Final Confirmation</H2>
<P>
<FORM action="'.$PHP_SELF.'" method="post">
<p>Language: <b>'.$lang_name.'</b></p>
<B>Description:</B><BR>
<TEXTAREA name="form_purpose" wrap="virtual" cols="70" rows="15">'.$reg_purpose.'</TEXTAREA>
<P>
<B>Full Name:</B><BR>
<INPUT size="40" maxlength="40" type="text" name="form_full_name" VALUE="'.$reg_name.'">
<P>
<B>Unix Name:</B><BR>
'.$reg_unixname.'
<P>
If you agree, your project will be created. If you disagree, it will be
deleted from the system.  You can also back up to any point to change
settings.
<P>
<INPUT type=submit name="i_agree" value="I AGREE"> <INPUT type=submit name="i_disagree" value="I DISAGREE">
</FORM>';

site_footer();

?>
